var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

var BreadcrumbItem = function BreadcrumbItem(_ref) {
  var _classNames;

  var icon = _ref.icon,
      isActive = _ref.isActive,
      className = _ref.className,
      children = _ref.children,
      element = _ref.element,
      href = _ref.href,
      onClick = _ref.onClick,
      props = _objectWithoutProperties(_ref, ['icon', 'isActive', 'className', 'children', 'element', 'href', 'onClick']);

  var Element = element;
  return React.createElement(
    'li',
    { className: classNames((_classNames = { 'is-active': isActive }, _classNames[className] = Boolean(className), _classNames)) },
    React.createElement(
      Element,
      _extends({
        onClick: onClick
      }, isActive ? { 'aria-current': 'page' } : {}, element === 'a' ? { href: href } : {}, props),
      icon && React.createElement(
        'span',
        { className: 'icon is-small' },
        React.createElement('i', { className: icon, 'aria-hidden': 'true' })
      ),
      children
    )
  );
};

BreadcrumbItem.propTypes = process.env.NODE_ENV !== "production" ? {
  /** Breadcrumb icon name */
  icon: PropTypes.string,
  /** Whether or not the breadcrumb is active */
  isActive: PropTypes.bool,
  children: PropTypes.node,
  className: PropTypes.string,
  element: PropTypes.oneOfType([PropTypes.string, PropTypes.element]),
  href: PropTypes.string,
  onClick: PropTypes.func
} : {};

BreadcrumbItem.defaultProps = {
  icon: null,
  isActive: false,
  children: null,
  className: null,
  element: 'a',
  href: null,
  onClick: null
};

export default BreadcrumbItem;