var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import * as sharedPropTypes from '../_prop-types';

var Button = function Button(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      color = _ref.color,
      element = _ref.element,
      isInverted = _ref.isInverted,
      isLoading = _ref.isLoading,
      isOutlined = _ref.isOutlined,
      isRounded = _ref.isRounded,
      isSelected = _ref.isSelected,
      isStatic = _ref.isStatic,
      size = _ref.size,
      state = _ref.state,
      props = _objectWithoutProperties(_ref, ['children', 'className', 'color', 'element', 'isInverted', 'isLoading', 'isOutlined', 'isRounded', 'isSelected', 'isStatic', 'size', 'state']);

  var Element = element;
  return React.createElement(
    Element,
    _extends({
      className: classNames('button', (_classNames = {}, _classNames['is-' + color] = Boolean(color), _classNames['is-' + size] = Boolean(size), _classNames['is-inverted'] = isInverted, _classNames['is-loading'] = isLoading, _classNames['is-outlined'] = isOutlined, _classNames['is-rounded'] = isRounded, _classNames['is-selected'] = isSelected, _classNames['is-static'] = isStatic, _classNames['is-' + state] = Boolean(state), _classNames[className] = Boolean(className), _classNames))
    }, props),
    children
  );
};

Button.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node,
  className: PropTypes.string,
  /**
   * Button color. Available values: `white`, `light`, `dark`, `black`, `text`, `primary`, `link`, `info`, `success`, `warning`, `danger`
   */
  color: sharedPropTypes.color,
  /** Button element type */
  element: PropTypes.oneOfType([PropTypes.string, PropTypes.element]),
  /** Is button color inverted? */
  isInverted: PropTypes.bool,
  /** Is button loading? */
  isLoading: PropTypes.bool,
  /** Is button outlined? */
  isOutlined: PropTypes.bool,
  /** Is button round? */
  isRounded: PropTypes.bool,
  /** Is button selected? */
  isSelected: PropTypes.bool,
  /** Is button static? */
  isStatic: PropTypes.bool,
  /** Size of button. Available values: `small`, `medium`, `large` */
  size: sharedPropTypes.size,
  /** State of button. Available values: `hovered`, `active`, `focused` */
  state: sharedPropTypes.state
} : {};

Button.defaultProps = {
  children: null,
  className: null,
  color: null,
  element: 'button',
  isInverted: false,
  isLoading: false,
  isOutlined: false,
  isRounded: false,
  isSelected: false,
  isStatic: false,
  size: null,
  state: null
};

export default Button;