var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import * as sharedPropTypes from '../_prop-types';

import Field from '../Field/Field';
import FieldBody from '../Field/FieldBody';
import FieldControl from '../Field/FieldControl';
import FieldLabel from '../Field/FieldLabel';

var CheckboxField = function (_React$Component) {
  _inherits(CheckboxField, _React$Component);

  function CheckboxField() {
    var _temp, _this, _ret;

    _classCallCheck(this, CheckboxField);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.state = { isChecked: _this.props.isChecked }, _this.componentDidUpdate = function (prevProps) {
      var isChecked = _this.props.isChecked;
      var prevIsChecked = prevProps.isChecked;

      if (isChecked !== prevIsChecked) {
        _this.setState({ isChecked: isChecked });
      }
    }, _this.handleChange = function (isChecked) {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          propIsChecked = _this$props.isChecked;

      if (propIsChecked) return;
      _this.setState({ isChecked: isChecked });
      onChange && onChange(isChecked);
    }, _this.render = function () {
      var _classNames;

      var _this$props2 = _this.props,
          children = _this$props2.children,
          className = _this$props2.className,
          color = _this$props2.color,
          helpText = _this$props2.helpText,
          inputProps = _this$props2.inputProps,
          isDisabled = _this$props2.isDisabled,
          isHorizontal = _this$props2.isHorizontal,
          labelComponent = _this$props2.labelComponent,
          labelName = _this$props2.labelName,
          labelSize = _this$props2.labelSize,
          name = _this$props2.name,
          onChange = _this$props2.onChange,
          text = _this$props2.text,
          props = _objectWithoutProperties(_this$props2, ['children', 'className', 'color', 'helpText', 'inputProps', 'isDisabled', 'isHorizontal', 'labelComponent', 'labelName', 'labelSize', 'name', 'onChange', 'text']);

      var isChecked = _this.state.isChecked;

      return React.createElement(
        Field,
        _extends({ isHorizontal: isHorizontal }, props),
        (labelName || labelComponent) && React.createElement(
          FieldLabel,
          { isHorizontal: isHorizontal, size: labelSize },
          labelName || labelComponent
        ),
        React.createElement(
          FieldBody,
          null,
          React.createElement(
            Field,
            { color: color, helpText: helpText },
            React.createElement(
              FieldControl,
              null,
              React.createElement(
                'label',
                { className: classNames('checkbox', (_classNames = {}, _classNames[className] = Boolean(className), _classNames)), disabled: isDisabled },
                React.createElement('input', _extends({
                  'aria-label': labelName,
                  disabled: isDisabled,
                  name: name,
                  onChange: function onChange() {
                    return _this.handleChange(!isChecked);
                  },
                  type: 'checkbox'
                }, inputProps, {
                  checked: isChecked
                })),
                ' ',
                text
              )
            )
          )
        )
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  return CheckboxField;
}(React.Component);

CheckboxField.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node,
  className: PropTypes.string,
  /** Color of input field. */
  color: sharedPropTypes.color,
  /** Displays help text */
  helpText: PropTypes.oneOfType([PropTypes.string, PropTypes.element]),
  inputProps: PropTypes.object,
  /* Whether the checkbox is selected */
  isChecked: PropTypes.bool,
  /** Whether the checkbox is disabled. */
  isDisabled: PropTypes.bool,
  /** The label that appears above the input */
  labelComponent: PropTypes.element,
  /** The label that appears above the input */
  labelName: PropTypes.string,
  /** Size of the label field */
  labelSize: sharedPropTypes.size,
  /** Input field is horizontal */
  isHorizontal: PropTypes.bool,
  /** Name of the input field */
  name: PropTypes.string,
  /** Function to invoke on change */
  onChange: PropTypes.func,
  /** Text to display next to the checkbox */
  text: PropTypes.oneOfType([PropTypes.string, PropTypes.element]).isRequired
} : {};

CheckboxField.defaultProps = {
  children: null,
  className: null,
  color: null,
  helpText: null,
  inputProps: {},
  isChecked: false,
  isDisabled: false,
  labelComponent: null,
  labelName: null,
  labelSize: null,
  isHorizontal: false,
  name: null,
  onChange: null
};

export default CheckboxField;