import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

var Columns = function Columns(_ref) {
  var _classNames;

  var breakpoint = _ref.breakpoint,
      children = _ref.children,
      className = _ref.className,
      isGapless = _ref.isGapless,
      isMultiline = _ref.isMultiline;
  return React.createElement(
    'div',
    {
      className: classNames('columns', (_classNames = {}, _classNames['is-' + breakpoint] = breakpoint, _classNames['is-gapless'] = isGapless, _classNames['is-multiline'] = isMultiline, _classNames[className] = Boolean(className), _classNames))
    },
    children
  );
};

Columns.propTypes = process.env.NODE_ENV !== "production" ? {
  /** Minimum breakpoint of where responsive columns is effective. Available values: `mobile`, `tablet`, `desktop`, `widescreen`, `fullhd` */
  breakpoint: PropTypes.oneOf(['mobile', 'tablet', 'desktop', 'widescreen', 'fullhd']),
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  /** Do the columns have no gaps? */
  isGapless: PropTypes.bool,
  /** Do the columns span on multiple lines? */
  isMultiline: PropTypes.bool
} : {};

Columns.defaultProps = {
  breakpoint: null,
  className: null,
  isGapless: false,
  isMultiline: false
};

export default Columns;