import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

var CONTAINER_SIZES = ['fluid', 'desktop', 'widescreen', 'fullhd'];

var Container = function Container(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      size = _ref.size;
  return React.createElement(
    'div',
    {
      className: classNames('container', (_classNames = {}, _classNames['is-' + size] = Boolean(size), _classNames[className] = Boolean(className), _classNames))
    },
    children
  );
};

Container.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  /** Available values: `fluid`, `desktop`, `widescreen`, `fullhd` */
  size: PropTypes.oneOf(CONTAINER_SIZES)
} : {};

Container.defaultProps = {
  className: null,
  size: null
};

export default Container;