var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import Toggle from 'react-toggled';

import * as sharedPropTypes from '../_prop-types';
import ClickOutside from '../utils/ClickOutside';
import DropdownContent from './DropdownContent';
import DropdownDivider from './DropdownDivider';
import DropdownItem from './DropdownItem';
import DropdownMenu from './DropdownMenu';
import DropdownTrigger from './DropdownTrigger';

var _React$createContext = React.createContext({ closeOnItemClick: true }),
    Provider = _React$createContext.Provider,
    Consumer = _React$createContext.Consumer;

export { Provider, Consumer };
var Dropdown = (_temp2 = _class = function (_React$Component) {
  _inherits(Dropdown, _React$Component);

  function Dropdown() {
    var _temp, _this, _ret;

    _classCallCheck(this, Dropdown);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.getDropdownProps = function (togglerProps) {
      return _extends({}, togglerProps, {
        'aria-haspopup': 'true',
        'aria-controls': 'dropdown-menu'
      });
    }, _this.render = function () {
      var _this$props = _this.props,
          align = _this$props.align,
          children = _this$props.children,
          className = _this$props.className,
          closeOnItemClick = _this$props.closeOnItemClick,
          initiallyIsActive = _this$props.initiallyIsActive,
          isActive = _this$props.isActive,
          isDropup = _this$props.isDropup,
          isHoverable = _this$props.isHoverable,
          menuId = _this$props.menuId,
          trigger = _this$props.trigger,
          props = _objectWithoutProperties(_this$props, ['align', 'children', 'className', 'closeOnItemClick', 'initiallyIsActive', 'isActive', 'isDropup', 'isHoverable', 'menuId', 'trigger']);

      return React.createElement(
        Toggle,
        _extends({ defaultOn: initiallyIsActive }, isActive !== null ? { on: isActive } : {}),
        function (_ref) {
          var _classNames;

          var getTogglerElementProps = _ref.getTogglerElementProps,
              getTogglerProps = _ref.getTogglerProps,
              on = _ref.on,
              show = _ref.setOn,
              hide = _ref.setOff,
              toggle = _ref.toggle;
          return React.createElement(
            'div',
            _extends({
              className: classNames('dropdown', (_classNames = {}, _classNames['is-' + align] = align, _classNames['is-active'] = on, _classNames['is-up'] = Boolean(isDropup), _classNames['is-hoverable'] = Boolean(isHoverable), _classNames[className] = Boolean(className), _classNames))
            }, props),
            React.createElement(
              ClickOutside,
              { onClickOutside: hide },
              trigger && React.createElement(
                DropdownTrigger,
                null,
                trigger({
                  getDropdownButtonProps: function getDropdownButtonProps() {
                    return _this.getDropdownProps(getTogglerProps());
                  },
                  getDropdownElementProps: function getDropdownElementProps() {
                    return _this.getDropdownProps(getTogglerElementProps());
                  },
                  show: show,
                  hide: hide,
                  toggle: toggle
                })
              ),
              React.createElement(
                Provider,
                { value: { closeOnItemClick: closeOnItemClick, hide: hide } },
                React.createElement(
                  DropdownMenu,
                  { menuId: menuId },
                  React.createElement(
                    DropdownContent,
                    null,
                    children
                  )
                )
              )
            )
          );
        }
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  return Dropdown;
}(React.Component), _class.Divider = DropdownDivider, _class.Item = DropdownItem, _temp2);


Dropdown.propTypes = process.env.NODE_ENV !== "production" ? {
  /** Alignment of the dropdown. Available values: `left`, `centered`, `right` */
  align: sharedPropTypes.align,
  children: PropTypes.node,
  className: PropTypes.string,
  /** Close the menu when an item is clicked */
  closeOnItemClick: PropTypes.bool,
  /** Default active state of the dropdown */
  initiallyIsActive: PropTypes.bool,
  /** Controlled active state of the dropdown */
  isActive: PropTypes.bool,
  /** Is the dropdown actually a dropup?! */
  isDropup: PropTypes.bool,
  /** Is the dropdown hoverable? */
  isHoverable: PropTypes.bool,
  menuId: PropTypes.string,
  /** `trigger` is a function that returns a component. See more about its render props below */
  trigger: PropTypes.func
} : {};

Dropdown.defaultProps = {
  align: null,
  children: null,
  className: null,
  closeOnItemClick: true,
  initiallyIsActive: false,
  isActive: null,
  isDropup: false,
  isHoverable: false,
  menuId: null,
  trigger: null
};

export default Dropdown;