import React from 'react';
import PropTypes from 'prop-types';

var DropdownMenu = function DropdownMenu(_ref) {
  var children = _ref.children,
      menuId = _ref.menuId;
  return React.createElement(
    'div',
    { id: menuId, className: 'dropdown-menu', role: 'menu' },
    children
  );
};

DropdownMenu.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node.isRequired,
  menuId: PropTypes.string
} : {};

DropdownMenu.defaultProps = {
  menuId: null
};

export default DropdownMenu;