function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import * as sharedPropTypes from '../_prop-types';

var Label = function Label(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      size = _ref.size;
  return React.createElement(
    'label',
    {
      className: classNames('label', (_classNames = {}, _classNames['is-' + size] = Boolean(size), _classNames[className] = Boolean(className), _classNames))
    },
    children
  );
};

var FieldLabel = function FieldLabel(_ref2) {
  var children = _ref2.children,
      className = _ref2.className,
      isHorizontal = _ref2.isHorizontal,
      isNormal = _ref2.isNormal,
      size = _ref2.size,
      props = _objectWithoutProperties(_ref2, ['children', 'className', 'isHorizontal', 'isNormal', 'size']);

  return isHorizontal ? React.createElement(
    'div',
    {
      className: classNames({
        'field-label': isHorizontal,
        'is-normal': isNormal
      })
    },
    React.createElement(
      Label,
      { className: className, size: size },
      children
    )
  ) : React.createElement(
    Label,
    { className: className, size: size },
    children
  );
};

Label.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  size: sharedPropTypes.size
} : {};

Label.defaultProps = {
  className: null,
  size: null
};

FieldLabel.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  isHorizontal: PropTypes.bool,
  isNormal: PropTypes.bool,
  size: sharedPropTypes.size
} : {};

FieldLabel.defaultProps = {
  className: null,
  isHorizontal: false,
  isNormal: false,
  size: null
};

export default FieldLabel;