import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import * as sharedPropTypes from '../_prop-types';

var HelpText = function HelpText(_ref) {
  var _classNames;

  var color = _ref.color,
      children = _ref.children;
  return React.createElement(
    'p',
    {
      className: classNames('help', (_classNames = {}, _classNames['is-' + color] = color, _classNames))
    },
    children
  );
};

HelpText.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node.isRequired,
  color: sharedPropTypes.color
} : {};

HelpText.defaultProps = {
  color: null
};

export default HelpText;