var _class, _temp2;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import * as sharedPropTypes from '../_prop-types';
import HeroHead from './HeroHead';
import HeroBody from './HeroBody';
import HeroFoot from './HeroFoot';

var HERO_SIZES = ['medium', 'large', 'fullheight'];

var Hero = (_temp2 = _class = function (_React$Component) {
  _inherits(Hero, _React$Component);

  function Hero() {
    var _temp, _this, _ret;

    _classCallCheck(this, Hero);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.render = function () {
      var _classNames;

      var _this$props = _this.props,
          children = _this$props.children,
          className = _this$props.className,
          color = _this$props.color,
          isBold = _this$props.isBold,
          size = _this$props.size;

      return React.createElement(
        'div',
        {
          className: classNames('hero', (_classNames = {}, _classNames['is-' + size] = Boolean(size), _classNames['is-' + color] = Boolean(color), _classNames['is-bold'] = isBold, _classNames[className] = Boolean(className), _classNames))
        },
        children
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  return Hero;
}(React.Component), _class.Head = HeroHead, _class.Body = HeroBody, _class.Foot = HeroFoot, _temp2);


Hero.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  /** Adds a background color to hero. Available values: `white`, `light`, `dark`, `black`, `text`, `primary`, `link`, `info`, `success`, `warning`, `danger` */
  color: sharedPropTypes.color,
  /** If true, adds a gradient to hero */
  isBold: PropTypes.bool,
  /** Size of hero. Available values: `medium`, `large`, `fullheight` */
  size: PropTypes.oneOf(HERO_SIZES)
} : {};

Hero.defaultProps = {
  className: null,
  color: null,
  isBold: false,
  size: null
};

export default Hero;