var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import * as sharedPropTypes from '../_prop-types';

var Icon = function Icon(_ref) {
  var _classNames;

  var className = _ref.className,
      color = _ref.color,
      iconClass = _ref.iconClass,
      size = _ref.size,
      props = _objectWithoutProperties(_ref, ['className', 'color', 'iconClass', 'size']);

  return React.createElement(
    'span',
    _extends({
      className: classNames('icon', (_classNames = {}, _classNames['is-' + size] = Boolean(size), _classNames['has-text-' + color] = Boolean(color), _classNames[className] = Boolean(className), _classNames))
    }, props),
    React.createElement('i', { className: iconClass })
  );
};

Icon.propTypes = process.env.NODE_ENV !== "production" ? {
  className: PropTypes.string,
  /** Color of the icon. Available values: `white`, `light`, `dark`, `black`, `text`, `primary`, `link`, `info`, `success`, `warning`, `danger` */
  color: sharedPropTypes.color,
  /** Icon class name. Example (Font Awesome 5): `fa fa-home` */
  iconClass: PropTypes.string.isRequired,
  /** Size of the icon. Available values: `small`, `medium`, `large` */
  size: sharedPropTypes.size
} : {};

Icon.defaultProps = {
  className: null,
  color: null,
  size: null
};

export default Icon;