var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

var Image = function Image(_ref) {
  var _classNames;

  var alt = _ref.alt,
      className = _ref.className,
      size = _ref.size,
      src = _ref.src,
      props = _objectWithoutProperties(_ref, ['alt', 'className', 'size', 'src']);

  return React.createElement(
    'figure',
    _extends({
      className: classNames('image', (_classNames = {}, _classNames['is-' + size + 'x' + size] = Boolean(size), _classNames[className] = Boolean(className), _classNames))
    }, props),
    React.createElement('img', { src: src, alt: alt })
  );
};

Image.propTypes = process.env.NODE_ENV !== "production" ? {
  /** Image alt text */
  alt: PropTypes.string.isRequired,
  className: PropTypes.string,
  /** Size of image. Available values: `16`, `24`, `32`, `48`, `64`, `96`, `128` */
  size: PropTypes.oneOf(['16', '24', '32', '48', '64', '96', '128']).isRequired,
  /** Image source URL */
  src: PropTypes.string.isRequired
} : {};

Image.defaultProps = {
  className: null
};

export default Image;