var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import Toggle from 'react-toggled';

import ClickOutside from '../utils/ClickOutside';
import ModalCard from './ModalCard';
import ModalCardBody from './ModalCardBody';
import ModalCardFoot from './ModalCardFoot';
import ModalCardHead from './ModalCardHead';
import ModalCardTitle from './ModalCardTitle';

var Modal = (_temp2 = _class = function (_React$Component) {
  _inherits(Modal, _React$Component);

  function Modal() {
    var _temp, _this, _ret;

    _classCallCheck(this, Modal);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.render = function () {
      var _this$props = _this.props,
          children = _this$props.children,
          className = _this$props.className,
          initiallyIsActive = _this$props.initiallyIsActive,
          isActive = _this$props.isActive,
          trigger = _this$props.trigger;

      return React.createElement(
        Toggle,
        _extends({ defaultOn: initiallyIsActive }, isActive !== null ? { on: isActive } : {}),
        function (_ref) {
          var _classNames;

          var getTogglerElementProps = _ref.getTogglerElementProps,
              getTogglerProps = _ref.getTogglerProps,
              on = _ref.on,
              show = _ref.setOn,
              hide = _ref.setOff,
              toggle = _ref.toggle;
          return React.createElement(
            React.Fragment,
            null,
            trigger && trigger({
              getTriggerButtonProps: getTogglerProps,
              getTriggerElementProps: getTogglerElementProps,
              show: show,
              hide: hide,
              toggle: toggle
            }),
            React.createElement(
              'div',
              { className: classNames('modal', (_classNames = { 'is-active': on }, _classNames[className] = Boolean(className), _classNames)) },
              React.createElement('div', { className: 'modal-background' }),
              React.createElement(
                ClickOutside,
                { onClickOutside: hide },
                React.createElement(
                  'div',
                  { 'aria-modal': 'true', className: 'modal-content', role: 'dialog' },
                  typeof children === 'function' ? children({
                    getTriggerButtonProps: getTogglerProps,
                    getTriggerElementProps: getTogglerElementProps,
                    hide: hide
                  }) : children
                )
              )
            )
          );
        }
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  return Modal;
}(React.Component), _class.Card = ModalCard, _class.CardBody = ModalCardBody, _class.CardFoot = ModalCardFoot, _class.CardHead = ModalCardHead, _class.CardTitle = ModalCardTitle, _temp2);


Modal.propTypes = process.env.NODE_ENV !== "production" ? {
  /** Can be either a `node` or a `function`. If it is a `function`, see more about its render props below. */
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.func]).isRequired,
  className: PropTypes.string,
  /** Default active state of the modal */
  initiallyIsActive: PropTypes.bool,
  /** Controlled active state of the dropdown */
  isActive: PropTypes.bool,
  /** `trigger` is a function that returns a component. See more about its render props below */
  trigger: PropTypes.func
} : {};

Modal.defaultProps = {
  className: null,
  initiallyIsActive: false,
  isActive: null,
  trigger: null
};

export default Modal;