var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import Toggle from 'react-toggled';
import * as sharedPropTypes from '../_prop-types';

import NavbarBrand from './NavbarBrand';
import NavbarBurger from './NavbarBurger';
import NavbarDivider from './NavbarDivider';
import NavbarDropdown from './NavbarDropdown';
import NavbarItem from './NavbarItem';
import NavbarLink from './NavbarLink';
import NavbarMenu from './NavbarMenu';
import NavbarStart from './NavbarStart';
import NavbarEnd from './NavbarEnd';

var Navbar = (_temp2 = _class = function (_React$Component) {
  _inherits(Navbar, _React$Component);

  function Navbar() {
    var _temp, _this, _ret;

    _classCallCheck(this, Navbar);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.getBurgerProps = function () {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var _ref = arguments[1];
      var isMenuActive = _ref.isMenuActive,
          toggleMenuActive = _ref.toggleMenuActive;
      return _extends({}, props, {
        isActive: isMenuActive,
        onClick: function onClick() {
          props.onClick && props.onClick();
          toggleMenuActive();
        }
      });
    }, _this.getMenuProps = function () {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var _ref2 = arguments[1];
      var isMenuActive = _ref2.isMenuActive;
      return _extends({}, props, {
        isActive: isMenuActive
      });
    }, _this.render = function () {
      var _classNames;

      var _this$props = _this.props,
          children = _this$props.children,
          className = _this$props.className,
          color = _this$props.color,
          isMenuInitiallyActive = _this$props.isMenuInitiallyActive,
          isFixedBottom = _this$props.isFixedBottom,
          isFixedTop = _this$props.isFixedTop,
          isTransparent = _this$props.isTransparent,
          props = _objectWithoutProperties(_this$props, ['children', 'className', 'color', 'isMenuInitiallyActive', 'isFixedBottom', 'isFixedTop', 'isTransparent']);

      return React.createElement(
        'nav',
        _extends({
          className: classNames('navbar', (_classNames = {}, _classNames['is-' + color] = Boolean(color), _classNames['is-fixed-bottom'] = isFixedBottom, _classNames['is-fixed-top'] = isFixedTop, _classNames['is-transparent'] = isTransparent, _classNames[className] = Boolean(className), _classNames)),
          'aria-label': 'navigation'
        }, props),
        typeof children === 'function' ? React.createElement(
          Toggle,
          { defaultOn: isMenuInitiallyActive },
          function (_ref3) {
            var isMenuActive = _ref3.on,
                setMenuActive = _ref3.setOn,
                setMenuInactive = _ref3.setOff,
                toggleMenuActive = _ref3.toggle;
            return children({
              getBurgerProps: function getBurgerProps(props) {
                return _this.getBurgerProps(props, { isMenuActive: isMenuActive, toggleMenuActive: toggleMenuActive });
              },
              getMenuProps: function getMenuProps(props) {
                return _this.getMenuProps(props, { isMenuActive: isMenuActive });
              },
              isMenuActive: isMenuActive,
              setMenuActive: setMenuActive,
              setMenuInactive: setMenuInactive
            });
          }
        ) : children
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  return Navbar;
}(React.Component), _class.Brand = NavbarBrand, _class.Burger = NavbarBurger, _class.Divider = NavbarDivider, _class.Dropdown = NavbarDropdown, _class.End = NavbarEnd, _class.Item = NavbarItem, _class.Link = NavbarLink, _class.Menu = NavbarMenu, _class.Start = NavbarStart, _temp2);


Navbar.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  /** Color of the navbar. Available values: `white`, `light`, `dark`, `black`, `text`, `primary`, `link`, `info`, `success`, `warning`, `danger` */
  color: sharedPropTypes.color,
  /** If true, the menu is active by default. */
  isMenuInitiallyActive: PropTypes.bool,
  /** If true, fixes the navbar to the bottom of the page. */
  isFixedBottom: PropTypes.bool,
  /** If true, fixes the navbar to the top of the page. */
  isFixedTop: PropTypes.bool,
  /** If true, makes the navbar transparent. */
  isTransparent: PropTypes.bool
} : {};

Navbar.defaultProps = {
  className: null,
  color: null,
  isMenuInitiallyActive: false,
  isFixedBottom: false,
  isFixedTop: false,
  isTransparent: false
};

export default Navbar;