var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

var NavbarBrand = function NavbarBrand(_ref) {
  var _classNames;

  var className = _ref.className,
      isActive = _ref.isActive,
      onClick = _ref.onClick,
      target = _ref.target,
      props = _objectWithoutProperties(_ref, ['className', 'isActive', 'onClick', 'target']);

  return React.createElement(
    'a',
    _extends({
      'aria-label': 'menu',
      'aria-expanded': isActive ? 'true' : 'false',
      className: classNames('navbar-burger', (_classNames = { 'is-active': Boolean(isActive) }, _classNames[className] = Boolean(className), _classNames)),
      'data-target': target,
      onClick: onClick,
      role: 'button'
    }, props),
    React.createElement('span', { 'aria-hidden': 'true' }),
    React.createElement('span', { 'aria-hidden': 'true' }),
    React.createElement('span', { 'aria-hidden': 'true' })
  );
};

NavbarBrand.propTypes = process.env.NODE_ENV !== "production" ? {
  className: PropTypes.string,
  /** If true, the burger turns into a cross. */
  isActive: PropTypes.bool,
  onClick: PropTypes.func,
  /** ID of the menu section. E.g. Value would be `'menu'` if <Navbar.Menu id="menu"> */
  target: PropTypes.string
} : {};

NavbarBrand.defaultProps = {
  className: null,
  isActive: false,
  onClick: null,
  target: null
};

export default NavbarBrand;