var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

var NavbarDropdown = function NavbarDropdown(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      isBoxed = _ref.isBoxed,
      isRight = _ref.isRight,
      props = _objectWithoutProperties(_ref, ['children', 'className', 'isBoxed', 'isRight']);

  return React.createElement(
    'div',
    _extends({
      className: classNames('navbar-dropdown', (_classNames = {
        'is-boxed': isBoxed,
        'is-right': isRight
      }, _classNames[className] = Boolean(className), _classNames))
    }, props),
    children
  );
};

NavbarDropdown.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  /** If true, the dropdown is a boxed style */
  isBoxed: PropTypes.bool,
  /** If true, the dropdown is right aligned */
  isRight: PropTypes.bool
} : {};

NavbarDropdown.defaultProps = {
  className: null,
  isBoxed: false,
  isRight: false
};

export default NavbarDropdown;