var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

var NavbarMenu = function NavbarMenu(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      isActive = _ref.isActive,
      props = _objectWithoutProperties(_ref, ['children', 'className', 'isActive']);

  return React.createElement(
    'div',
    _extends({
      className: classNames('navbar-menu', (_classNames = {
        'is-active': isActive
      }, _classNames[className] = Boolean(className), _classNames))
    }, props),
    children
  );
};

NavbarMenu.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  /** If true, the menu is active */
  isActive: PropTypes.bool
} : {};

NavbarMenu.defaultProps = {
  className: null,
  isActive: false
};

export default NavbarMenu;