var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import * as sharedPropTypes from '../_prop-types';
import Delete from '../Delete/Delete';

var Notification = function Notification(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      color = _ref.color,
      onClickClose = _ref.onClickClose,
      props = _objectWithoutProperties(_ref, ['children', 'className', 'color', 'onClickClose']);

  return React.createElement(
    'div',
    _extends({
      className: classNames('notification', (_classNames = {}, _classNames['is-' + color] = Boolean(color), _classNames[className] = Boolean(className), _classNames))
    }, props),
    onClickClose && React.createElement(Delete, { onClick: onClickClose }),
    children
  );
};

Notification.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  /** Color of notifcation. Available values: `white`, `light`, `dark`, `black`, `text`, `primary`, `link`, `info`, `success`, `warning`, `danger` */
  color: sharedPropTypes.color,
  /** Function to invoke when close button clicked */
  onClickClose: PropTypes.func
} : {};

Notification.defaultProps = {
  className: null,
  color: null,
  onClickClose: null
};

export default Notification;