var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import * as sharedPropTypes from '../_prop-types';

import PaginationPrevious from './PaginationPrevious';
import PaginationNext from './PaginationNext';
import PaginationList from './PaginationList';
import PaginationLink from './PaginationLink';
import PaginationEllipsis from './PaginationEllipsis';

var Pagination = (_temp2 = _class = function (_React$Component) {
  _inherits(Pagination, _React$Component);

  function Pagination() {
    var _temp, _this, _ret;

    _classCallCheck(this, Pagination);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.render = function () {
      var _classNames;

      var _this$props = _this.props,
          align = _this$props.align,
          children = _this$props.children,
          className = _this$props.className,
          isRounded = _this$props.isRounded,
          size = _this$props.size,
          props = _objectWithoutProperties(_this$props, ['align', 'children', 'className', 'isRounded', 'size']);

      return React.createElement(
        'nav',
        _extends({
          className: classNames('pagination', (_classNames = {}, _classNames['is-' + align] = Boolean(align), _classNames['is-' + size] = Boolean(size), _classNames['is-rounded'] = isRounded, _classNames[className] = Boolean(className), _classNames)),
          'aria-label': 'pagination'
        }, props),
        children
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  return Pagination;
}(React.Component), _class.Previous = PaginationPrevious, _class.Next = PaginationNext, _class.List = PaginationList, _class.Link = PaginationLink, _class.Ellipsis = PaginationEllipsis, _temp2);


Pagination.propTypes = process.env.NODE_ENV !== "production" ? {
  /** Alignment of the pagination buttons. Available values: `left`, `centered`, `right` */
  align: sharedPropTypes.align,
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  /** Are the pagination buttons round? */
  isRounded: PropTypes.bool,
  /** Size of buttons. Available values: `small`, `medium`, `large` */
  size: sharedPropTypes.size
} : {};

Pagination.defaultProps = {
  align: 'left',
  className: null,
  isRounded: false,
  size: null
};

export default Pagination;