var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

var PaginationLink = function PaginationLink(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      Element = _ref.element,
      isCurrent = _ref.isCurrent,
      isDisabled = _ref.isDisabled,
      onClick = _ref.onClick,
      props = _objectWithoutProperties(_ref, ['children', 'className', 'element', 'isCurrent', 'isDisabled', 'onClick']);

  return React.createElement(
    'li',
    null,
    React.createElement(
      Element,
      _extends({
        className: classNames('pagination-link', (_classNames = {
          'is-current': isCurrent
        }, _classNames[className] = Boolean(className), _classNames)),
        disabled: isDisabled,
        onClick: onClick,
        tabIndex: 0
      }, props),
      children
    )
  );
};

PaginationLink.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  element: PropTypes.oneOfType([PropTypes.element, PropTypes.string]),
  /** Is it the current page? */
  isCurrent: PropTypes.bool,
  /** Is the button disabled? */
  isDisabled: PropTypes.bool,
  /** Function to invoke on click */
  onClick: PropTypes.func
} : {};

PaginationLink.defaultProps = {
  className: null,
  element: 'a',
  isCurrent: false,
  isDisabled: false,
  onClick: null
};

export default PaginationLink;