var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

var PaginationNext = function PaginationNext(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      Element = _ref.element,
      isDisabled = _ref.isDisabled,
      onClick = _ref.onClick,
      props = _objectWithoutProperties(_ref, ['children', 'className', 'element', 'isDisabled', 'onClick']);

  return React.createElement(
    Element,
    _extends({
      className: classNames('pagination-next', (_classNames = {}, _classNames[className] = Boolean(className), _classNames)),
      disabled: isDisabled,
      onClick: onClick,
      tabIndex: 0
    }, props),
    children
  );
};

PaginationNext.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node,
  className: PropTypes.string,
  element: PropTypes.oneOfType([PropTypes.element, PropTypes.string]),
  /** Is the button is disabled? */
  isDisabled: PropTypes.bool,
  /** Function to invoke on click */
  onClick: PropTypes.func
} : {};

PaginationNext.defaultProps = {
  children: 'Next',
  className: null,
  element: 'a',
  isDisabled: false,
  onClick: null
};

export default PaginationNext;