import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

var PanelBlock = function PanelBlock(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      Element = _ref.element,
      isActive = _ref.isActive;
  return React.createElement(
    Element,
    {
      className: classNames('panel-block', (_classNames = {
        'is-active': isActive
      }, _classNames[className] = Boolean(className), _classNames))
    },
    children
  );
};

PanelBlock.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  element: PropTypes.oneOfType([PropTypes.element, PropTypes.string]),
  isActive: PropTypes.bool
} : {};

PanelBlock.defaultProps = {
  className: null,
  element: 'div',
  isActive: false
};

export default PanelBlock;