var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import * as sharedPropTypes from '../_prop-types';

var Progress = function Progress(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      color = _ref.color,
      maxValue = _ref.maxValue,
      size = _ref.size,
      value = _ref.value,
      props = _objectWithoutProperties(_ref, ['children', 'className', 'color', 'maxValue', 'size', 'value']);

  return React.createElement(
    'progress',
    _extends({
      className: classNames('progress', (_classNames = {}, _classNames['is-' + color] = color, _classNames['is-' + size] = size, _classNames[className] = Boolean(className), _classNames)),
      max: maxValue,
      value: value
    }, props),
    children
  );
};

Progress.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node,
  className: PropTypes.string,
  /** Color of notifcation. Available values: `white`, `light`, `dark`, `black`, `text`, `primary`, `link`, `info`, `success`, `warning`, `danger` */
  color: sharedPropTypes.color,
  /** Max value */
  maxValue: PropTypes.string,
  /** Size of progress bar. Available values: `small`, `medium`, `large` */
  size: sharedPropTypes.size,
  /** Value of progress bar */
  value: PropTypes.string.isRequired
} : {};

Progress.defaultProps = {
  children: null,
  className: null,
  color: null,
  maxValue: '100',
  size: null
};

export default Progress;