var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import TableHead from './TableHead';
import TableBody from './TableBody';
import TableFoot from './TableFoot';
import TableRow from './TableRow';
import TableCell from './TableCell';
import TableCellHead from './TableCellHead';

var Table = (_temp2 = _class = function (_React$Component) {
  _inherits(Table, _React$Component);

  function Table() {
    var _temp, _this, _ret;

    _classCallCheck(this, Table);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.render = function () {
      var _classNames;

      var _this$props = _this.props,
          children = _this$props.children,
          className = _this$props.className,
          isBordered = _this$props.isBordered,
          isFullWidth = _this$props.isFullWidth,
          isHoverable = _this$props.isHoverable,
          isNarrow = _this$props.isNarrow,
          isStriped = _this$props.isStriped,
          props = _objectWithoutProperties(_this$props, ['children', 'className', 'isBordered', 'isFullWidth', 'isHoverable', 'isNarrow', 'isStriped']);

      return React.createElement(
        'table',
        _extends({
          className: classNames('table', (_classNames = {
            'is-bordered': isBordered,
            'is-fullwidth': isFullWidth,
            'is-hoverable': isHoverable,
            'is-narrow': isNarrow,
            'is-striped': isStriped
          }, _classNames[className] = Boolean(className), _classNames))
        }, props),
        children
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  return Table;
}(React.Component), _class.Head = TableHead, _class.Body = TableBody, _class.Foot = TableFoot, _class.Row = TableRow, _class.Cell = TableCell, _class.CellHead = TableCellHead, _temp2);


Table.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  /** Is the table bordered? */
  isBordered: PropTypes.bool,
  /** Is the table full width? */
  isFullWidth: PropTypes.bool,
  /** Is the table hoverable? */
  isHoverable: PropTypes.bool,
  /** Is the table narrow? */
  isNarrow: PropTypes.bool,
  /** Is the table striped? */
  isStriped: PropTypes.bool
} : {};

Table.defaultProps = {
  className: null,
  isBordered: false,
  isFullWidth: false,
  isHoverable: false,
  isNarrow: false,
  isStriped: false
};

export default Table;