var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

var TableRow = function TableRow(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      isSelected = _ref.isSelected,
      props = _objectWithoutProperties(_ref, ['children', 'className', 'isSelected']);

  return React.createElement(
    'tr',
    _extends({
      className: classNames((_classNames = {
        'is-selected': isSelected
      }, _classNames[className] = Boolean(className), _classNames))
    }, props),
    children
  );
};

TableRow.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  isSelected: PropTypes.bool
} : {};

TableRow.defaultProps = {
  className: null,
  isSelected: false
};

export default TableRow;