var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import * as sharedPropTypes from '../_prop-types';

var Tabs = function Tabs(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      align = _ref.align,
      size = _ref.size,
      isBoxed = _ref.isBoxed,
      isToggle = _ref.isToggle,
      isToggleRounded = _ref.isToggleRounded,
      isFullWidth = _ref.isFullWidth,
      props = _objectWithoutProperties(_ref, ['children', 'className', 'align', 'size', 'isBoxed', 'isToggle', 'isToggleRounded', 'isFullWidth']);

  return React.createElement(
    'div',
    _extends({
      className: classNames('tabs', (_classNames = {}, _classNames['is-' + align] = align, _classNames['is-' + size] = size, _classNames['is-boxed'] = isBoxed, _classNames['is-toggle'] = isToggle, _classNames['is-toggle-rounded'] = isToggleRounded, _classNames['is-fullwidth'] = isFullWidth, _classNames[className] = Boolean(className), _classNames))
    }, props),
    React.createElement(
      'ul',
      null,
      children
    )
  );
};

Tabs.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  /** Alignment of the dropdown. Available values: `left`, `centered`, `right` */
  align: sharedPropTypes.align,
  /** Size of the tabs Available values: `small`, `medium`, `large` */
  size: sharedPropTypes.size,
  /** Are tabs box styled? */
  isBoxed: PropTypes.boolean,
  /** Are tabs toggle styled? */
  isToggle: PropTypes.boolean,
  /** Are tabs rounded toggle styled? */
  isToggleRounded: PropTypes.boolean,
  /** Are tabs fullwidth? */
  isFullWidth: PropTypes.boolean
} : {};

Tabs.defaultProps = {
  className: null,
  align: null,
  size: null,
  isBoxed: false,
  isToggle: false,
  isToggleRounded: false,
  isFullWidth: false
};

export default Tabs;