var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteralLoose(['\n  ', ';\n'], ['\n  ', ';\n']);

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _taggedTemplateLiteralLoose(strings, raw) { strings.raw = raw; return strings; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import styled from 'styled-components';
import { space } from 'styled-system';
import * as sharedPropTypes from '../_prop-types';
import Delete from '../Delete/Delete';

var DeleteWrapper = styled.span(_templateObject, space);

var getDeleteWrapperMarginLeft = function getDeleteWrapperMarginLeft(_ref) {
  var children = _ref.children,
      size = _ref.size;

  if (children) {
    return size === 'medium' || size === 'large' ? 2 : 1;
  }
  return 0;
};

var Tag = function Tag(_ref2) {
  var _classNames;

  var children = _ref2.children,
      className = _ref2.className,
      color = _ref2.color,
      isRounded = _ref2.isRounded,
      onClickDelete = _ref2.onClickDelete,
      size = _ref2.size,
      props = _objectWithoutProperties(_ref2, ['children', 'className', 'color', 'isRounded', 'onClickDelete', 'size']);

  return React.createElement(
    'span',
    _extends({
      className: classNames('tag', (_classNames = {}, _classNames['is-' + color] = Boolean(color), _classNames['is-' + size] = Boolean(size), _classNames['is-rounded'] = isRounded, _classNames[className] = Boolean(className), _classNames))
    }, props),
    children,
    onClickDelete && React.createElement(
      DeleteWrapper,
      { ml: getDeleteWrapperMarginLeft({ children: children, size: size }) },
      React.createElement(Delete, { onClick: onClickDelete, size: size })
    )
  );
};

Tag.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node,
  className: PropTypes.string,
  /** Tag color. Available values: `white`, `light`, `dark`, `black`, `text`, `primary`, `link`, `info`, `success`, `warning`, `danger` */
  color: sharedPropTypes.color,
  /** Is tag round? */
  isRounded: PropTypes.bool,
  /** Function to invoke when the delete button is pressed. Delete button is visible when `onClickDelete` is populated. */
  onClickDelete: PropTypes.func,
  /** Size of tag. Available values: `medium`, `large` */
  size: sharedPropTypes.size
} : {};

Tag.defaultProps = {
  children: null,
  className: null,
  color: null,
  isRounded: false,
  onClickDelete: null,
  size: 'small'
};

export default Tag;