var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

var Title = function Title(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      element = _ref.element,
      isSpaced = _ref.isSpaced,
      isSubTitle = _ref.isSubTitle,
      size = _ref.size,
      props = _objectWithoutProperties(_ref, ['children', 'className', 'element', 'isSpaced', 'isSubTitle', 'size']);

  var Element = element || 'h' + (size || '1');
  return React.createElement(
    Element,
    _extends({
      className: classNames((_classNames = {}, _classNames['is-' + size] = Boolean(size), _classNames['is-spaced'] = isSpaced, _classNames.title = !isSubTitle, _classNames.subtitle = isSubTitle, _classNames[className] = Boolean(className), _classNames))
    }, props),
    children
  );
};

Title.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  /** Custom element to use for title. Example: `'p'` */
  element: PropTypes.oneOfType([PropTypes.string, PropTypes.element]),
  /** Does the title have padding? */
  isSpaced: PropTypes.bool,
  /** Is the title a subtitle? */
  isSubTitle: PropTypes.bool,
  /** Size of title. Available values: `"1"`, `"2"`, `"3"`, `"4"`, `"5"`, `"6"` */
  size: PropTypes.oneOf(['1', '2', '3', '4', '5', '6'])
} : {};

Title.defaultProps = {
  className: null,
  element: null,
  isSpaced: false,
  isSubTitle: false,
  size: null
};

export default Title;