var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';

var ClickOutside = function (_React$Component) {
  _inherits(ClickOutside, _React$Component);

  function ClickOutside() {
    var _temp, _this, _ret;

    _classCallCheck(this, ClickOutside);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.container = React.createRef(), _this.componentDidMount = function () {
      document.addEventListener('touchend', _this.handleClickDocument, true);
      document.addEventListener('click', _this.handleClickDocument, true);
    }, _this.componentWillUnmount = function () {
      document.removeEventListener('touchend', _this.handleClickDocument, true);
      document.removeEventListener('click', _this.handleClickDocument, true);
    }, _this.handleClickDocument = function (e) {
      var onClickOutside = _this.props.onClickOutside;

      if (e.type === 'touchend' && e.type === 'click') {
        return;
      }
      var element = _this.container.current;
      if (!element.contains(e.target)) {
        onClickOutside(e);
      }
    }, _this.render = function () {
      var _this$props = _this.props,
          children = _this$props.children,
          props = _objectWithoutProperties(_this$props, ['children']);

      return React.createElement(
        'div',
        _extends({ ref: _this.container }, props),
        children
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  return ClickOutside;
}(React.Component);

export { ClickOutside as default };
ClickOutside.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node.isRequired,
  onClickOutside: PropTypes.func.isRequired
} : {};