'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes3 = require('../_prop-types');

var sharedPropTypes = _interopRequireWildcard(_propTypes3);

var _BreadcrumbItem = require('./BreadcrumbItem');

var _BreadcrumbItem2 = _interopRequireDefault(_BreadcrumbItem);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Breadcrumb = (_temp2 = _class = function (_React$Component) {
  _inherits(Breadcrumb, _React$Component);

  function Breadcrumb() {
    var _temp, _this, _ret;

    _classCallCheck(this, Breadcrumb);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.render = function () {
      var _classNames;

      var _this$props = _this.props,
          align = _this$props.align,
          children = _this$props.children,
          className = _this$props.className,
          separator = _this$props.separator,
          size = _this$props.size,
          props = _objectWithoutProperties(_this$props, ['align', 'children', 'className', 'separator', 'size']);

      return _react2.default.createElement(
        'nav',
        _extends({
          'aria-label': 'breadcrumbs',
          className: (0, _classnames2.default)('breadcrumb', (_classNames = {}, _classNames['is-' + align] = Boolean(align), _classNames['has-' + separator + '-separator'] = Boolean(separator), _classNames['is-' + size] = Boolean(size), _classNames[className] = Boolean(className), _classNames))
        }, props),
        _react2.default.createElement(
          'ul',
          null,
          children
        )
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  return Breadcrumb;
}(_react2.default.Component), _class.Item = _BreadcrumbItem2.default, _temp2);


Breadcrumb.propTypes = process.env.NODE_ENV !== "production" ? {
  /** Alignment of the breadcrumbs. Available values: `left`, `centered`, `right` */
  align: sharedPropTypes.align,
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  /** Type of breadcrumb separator. Available values: `arrow`, `bullet`, `dot`, `succeeds` */
  separator: _propTypes2.default.oneOf(['arrow', 'bullet', 'dot', 'succeeds']),
  /** Size of the breadcrumbs. Available values: `small`, `medium`, `large` */
  size: sharedPropTypes.size
} : {};

Breadcrumb.defaultProps = {
  align: null,
  children: null,
  className: null,
  separator: null,
  size: null
};

exports.default = Breadcrumb;
module.exports = exports['default'];