'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var BreadcrumbItem = function BreadcrumbItem(_ref) {
  var _classNames;

  var icon = _ref.icon,
      isActive = _ref.isActive,
      className = _ref.className,
      children = _ref.children,
      element = _ref.element,
      href = _ref.href,
      onClick = _ref.onClick,
      props = _objectWithoutProperties(_ref, ['icon', 'isActive', 'className', 'children', 'element', 'href', 'onClick']);

  var Element = element;
  return _react2.default.createElement(
    'li',
    { className: (0, _classnames2.default)((_classNames = { 'is-active': isActive }, _classNames[className] = Boolean(className), _classNames)) },
    _react2.default.createElement(
      Element,
      _extends({
        onClick: onClick
      }, isActive ? { 'aria-current': 'page' } : {}, element === 'a' ? { href: href } : {}, props),
      icon && _react2.default.createElement(
        'span',
        { className: 'icon is-small' },
        _react2.default.createElement('i', { className: icon, 'aria-hidden': 'true' })
      ),
      children
    )
  );
};

BreadcrumbItem.propTypes = process.env.NODE_ENV !== "production" ? {
  /** Breadcrumb icon name */
  icon: _propTypes2.default.string,
  /** Whether or not the breadcrumb is active */
  isActive: _propTypes2.default.bool,
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  element: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),
  href: _propTypes2.default.string,
  onClick: _propTypes2.default.func
} : {};

BreadcrumbItem.defaultProps = {
  icon: null,
  isActive: false,
  children: null,
  className: null,
  element: 'a',
  href: null,
  onClick: null
};

exports.default = BreadcrumbItem;
module.exports = exports['default'];