'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes3 = require('../_prop-types');

var sharedPropTypes = _interopRequireWildcard(_propTypes3);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Button = function Button(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      color = _ref.color,
      element = _ref.element,
      isInverted = _ref.isInverted,
      isLoading = _ref.isLoading,
      isOutlined = _ref.isOutlined,
      isRounded = _ref.isRounded,
      isSelected = _ref.isSelected,
      isStatic = _ref.isStatic,
      size = _ref.size,
      state = _ref.state,
      props = _objectWithoutProperties(_ref, ['children', 'className', 'color', 'element', 'isInverted', 'isLoading', 'isOutlined', 'isRounded', 'isSelected', 'isStatic', 'size', 'state']);

  var Element = element;
  return _react2.default.createElement(
    Element,
    _extends({
      className: (0, _classnames2.default)('button', (_classNames = {}, _classNames['is-' + color] = Boolean(color), _classNames['is-' + size] = Boolean(size), _classNames['is-inverted'] = isInverted, _classNames['is-loading'] = isLoading, _classNames['is-outlined'] = isOutlined, _classNames['is-rounded'] = isRounded, _classNames['is-selected'] = isSelected, _classNames['is-static'] = isStatic, _classNames['is-' + state] = Boolean(state), _classNames[className] = Boolean(className), _classNames))
    }, props),
    children
  );
};

Button.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  /**
   * Button color. Available values: `white`, `light`, `dark`, `black`, `text`, `primary`, `link`, `info`, `success`, `warning`, `danger`
   */
  color: sharedPropTypes.color,
  /** Button element type */
  element: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),
  /** Is button color inverted? */
  isInverted: _propTypes2.default.bool,
  /** Is button loading? */
  isLoading: _propTypes2.default.bool,
  /** Is button outlined? */
  isOutlined: _propTypes2.default.bool,
  /** Is button round? */
  isRounded: _propTypes2.default.bool,
  /** Is button selected? */
  isSelected: _propTypes2.default.bool,
  /** Is button static? */
  isStatic: _propTypes2.default.bool,
  /** Size of button. Available values: `small`, `medium`, `large` */
  size: sharedPropTypes.size,
  /** State of button. Available values: `hovered`, `active`, `focused` */
  state: sharedPropTypes.state
} : {};

Button.defaultProps = {
  children: null,
  className: null,
  color: null,
  element: 'button',
  isInverted: false,
  isLoading: false,
  isOutlined: false,
  isRounded: false,
  isSelected: false,
  isStatic: false,
  size: null,
  state: null
};

exports.default = Button;
module.exports = exports['default'];