'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Columns = function Columns(_ref) {
  var _classNames;

  var breakpoint = _ref.breakpoint,
      children = _ref.children,
      className = _ref.className,
      isGapless = _ref.isGapless,
      isMultiline = _ref.isMultiline;
  return _react2.default.createElement(
    'div',
    {
      className: (0, _classnames2.default)('columns', (_classNames = {}, _classNames['is-' + breakpoint] = breakpoint, _classNames['is-gapless'] = isGapless, _classNames['is-multiline'] = isMultiline, _classNames[className] = Boolean(className), _classNames))
    },
    children
  );
};

Columns.propTypes = process.env.NODE_ENV !== "production" ? {
  /** Minimum breakpoint of where responsive columns is effective. Available values: `mobile`, `tablet`, `desktop`, `widescreen`, `fullhd` */
  breakpoint: _propTypes2.default.oneOf(['mobile', 'tablet', 'desktop', 'widescreen', 'fullhd']),
  children: _propTypes2.default.node.isRequired,
  className: _propTypes2.default.string,
  /** Do the columns have no gaps? */
  isGapless: _propTypes2.default.bool,
  /** Do the columns span on multiple lines? */
  isMultiline: _propTypes2.default.bool
} : {};

Columns.defaultProps = {
  breakpoint: null,
  className: null,
  isGapless: false,
  isMultiline: false
};

exports.default = Columns;
module.exports = exports['default'];