'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CONTAINER_SIZES = ['fluid', 'desktop', 'widescreen', 'fullhd'];

var Container = function Container(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      size = _ref.size;
  return _react2.default.createElement(
    'div',
    {
      className: (0, _classnames2.default)('container', (_classNames = {}, _classNames['is-' + size] = Boolean(size), _classNames[className] = Boolean(className), _classNames))
    },
    children
  );
};

Container.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes2.default.node.isRequired,
  className: _propTypes2.default.string,
  /** Available values: `fluid`, `desktop`, `widescreen`, `fullhd` */
  size: _propTypes2.default.oneOf(CONTAINER_SIZES)
} : {};

Container.defaultProps = {
  className: null,
  size: null
};

exports.default = Container;
module.exports = exports['default'];