'use strict';

exports.__esModule = true;
exports.Consumer = exports.Provider = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactToggled = require('react-toggled');

var _reactToggled2 = _interopRequireDefault(_reactToggled);

var _propTypes3 = require('../_prop-types');

var sharedPropTypes = _interopRequireWildcard(_propTypes3);

var _ClickOutside = require('../utils/ClickOutside');

var _ClickOutside2 = _interopRequireDefault(_ClickOutside);

var _DropdownContent = require('./DropdownContent');

var _DropdownContent2 = _interopRequireDefault(_DropdownContent);

var _DropdownDivider = require('./DropdownDivider');

var _DropdownDivider2 = _interopRequireDefault(_DropdownDivider);

var _DropdownItem = require('./DropdownItem');

var _DropdownItem2 = _interopRequireDefault(_DropdownItem);

var _DropdownMenu = require('./DropdownMenu');

var _DropdownMenu2 = _interopRequireDefault(_DropdownMenu);

var _DropdownTrigger = require('./DropdownTrigger');

var _DropdownTrigger2 = _interopRequireDefault(_DropdownTrigger);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _React$createContext = _react2.default.createContext({ closeOnItemClick: true }),
    Provider = _React$createContext.Provider,
    Consumer = _React$createContext.Consumer;

exports.Provider = Provider;
exports.Consumer = Consumer;
var Dropdown = (_temp2 = _class = function (_React$Component) {
  _inherits(Dropdown, _React$Component);

  function Dropdown() {
    var _temp, _this, _ret;

    _classCallCheck(this, Dropdown);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.getDropdownProps = function (togglerProps) {
      return _extends({}, togglerProps, {
        'aria-haspopup': 'true',
        'aria-controls': 'dropdown-menu'
      });
    }, _this.render = function () {
      var _this$props = _this.props,
          align = _this$props.align,
          children = _this$props.children,
          className = _this$props.className,
          closeOnItemClick = _this$props.closeOnItemClick,
          initiallyIsActive = _this$props.initiallyIsActive,
          isActive = _this$props.isActive,
          isDropup = _this$props.isDropup,
          isHoverable = _this$props.isHoverable,
          menuId = _this$props.menuId,
          trigger = _this$props.trigger,
          props = _objectWithoutProperties(_this$props, ['align', 'children', 'className', 'closeOnItemClick', 'initiallyIsActive', 'isActive', 'isDropup', 'isHoverable', 'menuId', 'trigger']);

      return _react2.default.createElement(
        _reactToggled2.default,
        _extends({ defaultOn: initiallyIsActive }, isActive !== null ? { on: isActive } : {}),
        function (_ref) {
          var _classNames;

          var getTogglerElementProps = _ref.getTogglerElementProps,
              getTogglerProps = _ref.getTogglerProps,
              on = _ref.on,
              show = _ref.setOn,
              hide = _ref.setOff,
              toggle = _ref.toggle;
          return _react2.default.createElement(
            'div',
            _extends({
              className: (0, _classnames2.default)('dropdown', (_classNames = {}, _classNames['is-' + align] = align, _classNames['is-active'] = on, _classNames['is-up'] = Boolean(isDropup), _classNames['is-hoverable'] = Boolean(isHoverable), _classNames[className] = Boolean(className), _classNames))
            }, props),
            _react2.default.createElement(
              _ClickOutside2.default,
              { onClickOutside: hide },
              trigger && _react2.default.createElement(
                _DropdownTrigger2.default,
                null,
                trigger({
                  getDropdownButtonProps: function getDropdownButtonProps() {
                    return _this.getDropdownProps(getTogglerProps());
                  },
                  getDropdownElementProps: function getDropdownElementProps() {
                    return _this.getDropdownProps(getTogglerElementProps());
                  },
                  show: show,
                  hide: hide,
                  toggle: toggle
                })
              ),
              _react2.default.createElement(
                Provider,
                { value: { closeOnItemClick: closeOnItemClick, hide: hide } },
                _react2.default.createElement(
                  _DropdownMenu2.default,
                  { menuId: menuId },
                  _react2.default.createElement(
                    _DropdownContent2.default,
                    null,
                    children
                  )
                )
              )
            )
          );
        }
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  return Dropdown;
}(_react2.default.Component), _class.Divider = _DropdownDivider2.default, _class.Item = _DropdownItem2.default, _temp2);


Dropdown.propTypes = process.env.NODE_ENV !== "production" ? {
  /** Alignment of the dropdown. Available values: `left`, `centered`, `right` */
  align: sharedPropTypes.align,
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  /** Close the menu when an item is clicked */
  closeOnItemClick: _propTypes2.default.bool,
  /** Default active state of the dropdown */
  initiallyIsActive: _propTypes2.default.bool,
  /** Controlled active state of the dropdown */
  isActive: _propTypes2.default.bool,
  /** Is the dropdown actually a dropup?! */
  isDropup: _propTypes2.default.bool,
  /** Is the dropdown hoverable? */
  isHoverable: _propTypes2.default.bool,
  menuId: _propTypes2.default.string,
  /** `trigger` is a function that returns a component. See more about its render props below */
  trigger: _propTypes2.default.func
} : {};

Dropdown.defaultProps = {
  align: null,
  children: null,
  className: null,
  closeOnItemClick: true,
  initiallyIsActive: false,
  isActive: null,
  isDropup: false,
  isHoverable: false,
  menuId: null,
  trigger: null
};

exports.default = Dropdown;