'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Dropdown = require('./Dropdown');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DropdownItem = function (_React$PureComponent) {
  _inherits(DropdownItem, _React$PureComponent);

  function DropdownItem() {
    var _temp, _this, _ret;

    _classCallCheck(this, DropdownItem);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$PureComponent.call.apply(_React$PureComponent, [this].concat(args))), _this), _this.handleClick = function (_ref) {
      var e = _ref.e,
          closeOnItemClick = _ref.closeOnItemClick,
          hide = _ref.hide;
      var onClick = _this.props.onClick;

      onClick && onClick(e);
      closeOnItemClick && hide();
    }, _this.render = function () {
      var _this$props = _this.props,
          children = _this$props.children,
          className = _this$props.className,
          Element = _this$props.element,
          isActive = _this$props.isActive,
          props = _objectWithoutProperties(_this$props, ['children', 'className', 'element', 'isActive']);

      return _react2.default.createElement(
        _Dropdown.Consumer,
        null,
        function (_ref2) {
          var _classNames;

          var closeOnItemClick = _ref2.closeOnItemClick,
              hide = _ref2.hide;
          return _react2.default.createElement(
            Element,
            _extends({
              className: (0, _classnames2.default)('dropdown-item', (_classNames = {
                'is-active': isActive
              }, _classNames[className] = Boolean(className), _classNames))
            }, props, {
              onClick: function onClick(e) {
                return _this.handleClick({ e: e, closeOnItemClick: closeOnItemClick, hide: hide });
              }
            }),
            children
          );
        }
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  return DropdownItem;
}(_react2.default.PureComponent);

DropdownItem.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes2.default.node.isRequired,
  className: _propTypes2.default.string,
  element: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),
  isActive: _propTypes2.default.bool,
  onClick: _propTypes2.default.func
} : {};

DropdownItem.defaultProps = {
  className: null,
  element: 'div',
  isActive: false,
  onClick: null
};

exports.default = DropdownItem;
module.exports = exports['default'];