'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes3 = require('../_prop-types');

var sharedPropTypes = _interopRequireWildcard(_propTypes3);

var _FieldBody = require('./FieldBody');

var _FieldBody2 = _interopRequireDefault(_FieldBody);

var _FieldControl = require('./FieldControl');

var _FieldControl2 = _interopRequireDefault(_FieldControl);

var _FieldLabel = require('./FieldLabel');

var _FieldLabel2 = _interopRequireDefault(_FieldLabel);

var _HelpText = require('./HelpText');

var _HelpText2 = _interopRequireDefault(_HelpText);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Field = (_temp2 = _class = function (_React$Component) {
  _inherits(Field, _React$Component);

  function Field() {
    var _temp, _this, _ret;

    _classCallCheck(this, Field);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.render = function () {
      var _classNames;

      var _this$props = _this.props,
          children = _this$props.children,
          className = _this$props.className,
          color = _this$props.color,
          hasAddons = _this$props.hasAddons,
          helpText = _this$props.helpText,
          isHorizontal = _this$props.isHorizontal,
          props = _objectWithoutProperties(_this$props, ['children', 'className', 'color', 'hasAddons', 'helpText', 'isHorizontal']);

      return _react2.default.createElement(
        'div',
        _extends({
          className: (0, _classnames2.default)('field', (_classNames = {
            'is-horizontal': isHorizontal,
            'has-addons': hasAddons
          }, _classNames[className] = Boolean(className), _classNames))
        }, props),
        children,
        helpText && _react2.default.createElement(
          _HelpText2.default,
          { color: color },
          helpText
        )
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  return Field;
}(_react2.default.Component), _class.Body = _FieldBody2.default, _class.Control = _FieldControl2.default, _class.Label = _FieldLabel2.default, _class.Text = _HelpText2.default, _temp2);


Field.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes2.default.node.isRequired,
  className: _propTypes2.default.string,
  color: sharedPropTypes.color,
  hasAddons: _propTypes2.default.bool,
  helpText: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),
  isHorizontal: _propTypes2.default.bool
} : {};

Field.defaultProps = {
  className: null,
  color: null,
  hasAddons: false,
  helpText: null,
  isHorizontal: false
};

exports.default = Field;
module.exports = exports['default'];