'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes3 = require('../_prop-types');

var sharedPropTypes = _interopRequireWildcard(_propTypes3);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var FieldControl = function FieldControl(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      color = _ref.color,
      isExpanded = _ref.isExpanded,
      isLoading = _ref.isLoading,
      leftIconName = _ref.leftIconName,
      rightIconName = _ref.rightIconName,
      props = _objectWithoutProperties(_ref, ['children', 'className', 'color', 'isExpanded', 'isLoading', 'leftIconName', 'rightIconName']);

  return _react2.default.createElement(
    'div',
    {
      className: (0, _classnames2.default)('control', (_classNames = {
        'is-expanded': isExpanded,
        'is-loading': isLoading,
        'has-icons-left': Boolean(leftIconName),
        'has-icons-right': Boolean(rightIconName)
      }, _classNames[className] = Boolean(className), _classNames))
    },
    children,
    leftIconName && _react2.default.createElement(
      'span',
      { className: 'icon is-small is-left' },
      _react2.default.createElement('i', { className: leftIconName })
    ),
    rightIconName && _react2.default.createElement(
      'span',
      { className: 'icon is-small is-right' },
      _react2.default.createElement('i', { className: rightIconName })
    )
  );
};

FieldControl.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes2.default.node.isRequired,
  className: _propTypes2.default.string,
  color: sharedPropTypes.color,
  isExpanded: _propTypes2.default.bool,
  isLoading: _propTypes2.default.bool,
  leftIconName: _propTypes2.default.string,
  rightIconName: _propTypes2.default.string
} : {};

FieldControl.defaultProps = {
  className: null,
  color: null,
  isExpanded: false,
  isLoading: false,
  leftIconName: null,
  rightIconName: null
};

exports.default = FieldControl;
module.exports = exports['default'];