'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes3 = require('../_prop-types');

var sharedPropTypes = _interopRequireWildcard(_propTypes3);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Label = function Label(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      size = _ref.size;
  return _react2.default.createElement(
    'label',
    {
      className: (0, _classnames2.default)('label', (_classNames = {}, _classNames['is-' + size] = Boolean(size), _classNames[className] = Boolean(className), _classNames))
    },
    children
  );
};

var FieldLabel = function FieldLabel(_ref2) {
  var children = _ref2.children,
      className = _ref2.className,
      isHorizontal = _ref2.isHorizontal,
      isNormal = _ref2.isNormal,
      size = _ref2.size,
      props = _objectWithoutProperties(_ref2, ['children', 'className', 'isHorizontal', 'isNormal', 'size']);

  return isHorizontal ? _react2.default.createElement(
    'div',
    {
      className: (0, _classnames2.default)({
        'field-label': isHorizontal,
        'is-normal': isNormal
      })
    },
    _react2.default.createElement(
      Label,
      { className: className, size: size },
      children
    )
  ) : _react2.default.createElement(
    Label,
    { className: className, size: size },
    children
  );
};

Label.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes2.default.node.isRequired,
  className: _propTypes2.default.string,
  size: sharedPropTypes.size
} : {};

Label.defaultProps = {
  className: null,
  size: null
};

FieldLabel.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes2.default.node.isRequired,
  className: _propTypes2.default.string,
  isHorizontal: _propTypes2.default.bool,
  isNormal: _propTypes2.default.bool,
  size: sharedPropTypes.size
} : {};

FieldLabel.defaultProps = {
  className: null,
  isHorizontal: false,
  isNormal: false,
  size: null
};

exports.default = FieldLabel;
module.exports = exports['default'];