'use strict';

exports.__esModule = true;

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes3 = require('../_prop-types');

var sharedPropTypes = _interopRequireWildcard(_propTypes3);

var _HeroHead = require('./HeroHead');

var _HeroHead2 = _interopRequireDefault(_HeroHead);

var _HeroBody = require('./HeroBody');

var _HeroBody2 = _interopRequireDefault(_HeroBody);

var _HeroFoot = require('./HeroFoot');

var _HeroFoot2 = _interopRequireDefault(_HeroFoot);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var HERO_SIZES = ['medium', 'large', 'fullheight'];

var Hero = (_temp2 = _class = function (_React$Component) {
  _inherits(Hero, _React$Component);

  function Hero() {
    var _temp, _this, _ret;

    _classCallCheck(this, Hero);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.render = function () {
      var _classNames;

      var _this$props = _this.props,
          children = _this$props.children,
          className = _this$props.className,
          color = _this$props.color,
          isBold = _this$props.isBold,
          size = _this$props.size;

      return _react2.default.createElement(
        'div',
        {
          className: (0, _classnames2.default)('hero', (_classNames = {}, _classNames['is-' + size] = Boolean(size), _classNames['is-' + color] = Boolean(color), _classNames['is-bold'] = isBold, _classNames[className] = Boolean(className), _classNames))
        },
        children
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  return Hero;
}(_react2.default.Component), _class.Head = _HeroHead2.default, _class.Body = _HeroBody2.default, _class.Foot = _HeroFoot2.default, _temp2);


Hero.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes2.default.node.isRequired,
  className: _propTypes2.default.string,
  /** Adds a background color to hero. Available values: `white`, `light`, `dark`, `black`, `text`, `primary`, `link`, `info`, `success`, `warning`, `danger` */
  color: sharedPropTypes.color,
  /** If true, adds a gradient to hero */
  isBold: _propTypes2.default.bool,
  /** Size of hero. Available values: `medium`, `large`, `fullheight` */
  size: _propTypes2.default.oneOf(HERO_SIZES)
} : {};

Hero.defaultProps = {
  className: null,
  color: null,
  isBold: false,
  size: null
};

exports.default = Hero;
module.exports = exports['default'];