'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes3 = require('../_prop-types');

var sharedPropTypes = _interopRequireWildcard(_propTypes3);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Icon = function Icon(_ref) {
  var _classNames;

  var className = _ref.className,
      color = _ref.color,
      iconClass = _ref.iconClass,
      size = _ref.size,
      props = _objectWithoutProperties(_ref, ['className', 'color', 'iconClass', 'size']);

  return _react2.default.createElement(
    'span',
    _extends({
      className: (0, _classnames2.default)('icon', (_classNames = {}, _classNames['is-' + size] = Boolean(size), _classNames['has-text-' + color] = Boolean(color), _classNames[className] = Boolean(className), _classNames))
    }, props),
    _react2.default.createElement('i', { className: iconClass })
  );
};

Icon.propTypes = process.env.NODE_ENV !== "production" ? {
  className: _propTypes2.default.string,
  /** Color of the icon. Available values: `white`, `light`, `dark`, `black`, `text`, `primary`, `link`, `info`, `success`, `warning`, `danger` */
  color: sharedPropTypes.color,
  /** Icon class name. Example (Font Awesome 5): `fa fa-home` */
  iconClass: _propTypes2.default.string.isRequired,
  /** Size of the icon. Available values: `small`, `medium`, `large` */
  size: sharedPropTypes.size
} : {};

Icon.defaultProps = {
  className: null,
  color: null,
  size: null
};

exports.default = Icon;
module.exports = exports['default'];