'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Image = function Image(_ref) {
  var _classNames;

  var alt = _ref.alt,
      className = _ref.className,
      size = _ref.size,
      src = _ref.src,
      props = _objectWithoutProperties(_ref, ['alt', 'className', 'size', 'src']);

  return _react2.default.createElement(
    'figure',
    _extends({
      className: (0, _classnames2.default)('image', (_classNames = {}, _classNames['is-' + size + 'x' + size] = Boolean(size), _classNames[className] = Boolean(className), _classNames))
    }, props),
    _react2.default.createElement('img', { src: src, alt: alt })
  );
};

Image.propTypes = process.env.NODE_ENV !== "production" ? {
  /** Image alt text */
  alt: _propTypes2.default.string.isRequired,
  className: _propTypes2.default.string,
  /** Size of image. Available values: `16`, `24`, `32`, `48`, `64`, `96`, `128` */
  size: _propTypes2.default.oneOf(['16', '24', '32', '48', '64', '96', '128']).isRequired,
  /** Image source URL */
  src: _propTypes2.default.string.isRequired
} : {};

Image.defaultProps = {
  className: null
};

exports.default = Image;
module.exports = exports['default'];