'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactToggled = require('react-toggled');

var _reactToggled2 = _interopRequireDefault(_reactToggled);

var _ClickOutside = require('../utils/ClickOutside');

var _ClickOutside2 = _interopRequireDefault(_ClickOutside);

var _ModalCard = require('./ModalCard');

var _ModalCard2 = _interopRequireDefault(_ModalCard);

var _ModalCardBody = require('./ModalCardBody');

var _ModalCardBody2 = _interopRequireDefault(_ModalCardBody);

var _ModalCardFoot = require('./ModalCardFoot');

var _ModalCardFoot2 = _interopRequireDefault(_ModalCardFoot);

var _ModalCardHead = require('./ModalCardHead');

var _ModalCardHead2 = _interopRequireDefault(_ModalCardHead);

var _ModalCardTitle = require('./ModalCardTitle');

var _ModalCardTitle2 = _interopRequireDefault(_ModalCardTitle);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Modal = (_temp2 = _class = function (_React$Component) {
  _inherits(Modal, _React$Component);

  function Modal() {
    var _temp, _this, _ret;

    _classCallCheck(this, Modal);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.render = function () {
      var _this$props = _this.props,
          children = _this$props.children,
          className = _this$props.className,
          initiallyIsActive = _this$props.initiallyIsActive,
          isActive = _this$props.isActive,
          trigger = _this$props.trigger;

      return _react2.default.createElement(
        _reactToggled2.default,
        _extends({ defaultOn: initiallyIsActive }, isActive !== null ? { on: isActive } : {}),
        function (_ref) {
          var _classNames;

          var getTogglerElementProps = _ref.getTogglerElementProps,
              getTogglerProps = _ref.getTogglerProps,
              on = _ref.on,
              show = _ref.setOn,
              hide = _ref.setOff,
              toggle = _ref.toggle;
          return _react2.default.createElement(
            _react2.default.Fragment,
            null,
            trigger && trigger({
              getTriggerButtonProps: getTogglerProps,
              getTriggerElementProps: getTogglerElementProps,
              show: show,
              hide: hide,
              toggle: toggle
            }),
            _react2.default.createElement(
              'div',
              { className: (0, _classnames2.default)('modal', (_classNames = { 'is-active': on }, _classNames[className] = Boolean(className), _classNames)) },
              _react2.default.createElement('div', { className: 'modal-background' }),
              _react2.default.createElement(
                _ClickOutside2.default,
                { onClickOutside: hide },
                _react2.default.createElement(
                  'div',
                  { 'aria-modal': 'true', className: 'modal-content', role: 'dialog' },
                  typeof children === 'function' ? children({
                    getTriggerButtonProps: getTogglerProps,
                    getTriggerElementProps: getTogglerElementProps,
                    hide: hide
                  }) : children
                )
              )
            )
          );
        }
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  return Modal;
}(_react2.default.Component), _class.Card = _ModalCard2.default, _class.CardBody = _ModalCardBody2.default, _class.CardFoot = _ModalCardFoot2.default, _class.CardHead = _ModalCardHead2.default, _class.CardTitle = _ModalCardTitle2.default, _temp2);


Modal.propTypes = process.env.NODE_ENV !== "production" ? {
  /** Can be either a `node` or a `function`. If it is a `function`, see more about its render props below. */
  children: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.func]).isRequired,
  className: _propTypes2.default.string,
  /** Default active state of the modal */
  initiallyIsActive: _propTypes2.default.bool,
  /** Controlled active state of the dropdown */
  isActive: _propTypes2.default.bool,
  /** `trigger` is a function that returns a component. See more about its render props below */
  trigger: _propTypes2.default.func
} : {};

Modal.defaultProps = {
  className: null,
  initiallyIsActive: false,
  isActive: null,
  trigger: null
};

exports.default = Modal;
module.exports = exports['default'];