'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactToggled = require('react-toggled');

var _reactToggled2 = _interopRequireDefault(_reactToggled);

var _propTypes3 = require('../_prop-types');

var sharedPropTypes = _interopRequireWildcard(_propTypes3);

var _NavbarBrand = require('./NavbarBrand');

var _NavbarBrand2 = _interopRequireDefault(_NavbarBrand);

var _NavbarBurger = require('./NavbarBurger');

var _NavbarBurger2 = _interopRequireDefault(_NavbarBurger);

var _NavbarDivider = require('./NavbarDivider');

var _NavbarDivider2 = _interopRequireDefault(_NavbarDivider);

var _NavbarDropdown = require('./NavbarDropdown');

var _NavbarDropdown2 = _interopRequireDefault(_NavbarDropdown);

var _NavbarItem = require('./NavbarItem');

var _NavbarItem2 = _interopRequireDefault(_NavbarItem);

var _NavbarLink = require('./NavbarLink');

var _NavbarLink2 = _interopRequireDefault(_NavbarLink);

var _NavbarMenu = require('./NavbarMenu');

var _NavbarMenu2 = _interopRequireDefault(_NavbarMenu);

var _NavbarStart = require('./NavbarStart');

var _NavbarStart2 = _interopRequireDefault(_NavbarStart);

var _NavbarEnd = require('./NavbarEnd');

var _NavbarEnd2 = _interopRequireDefault(_NavbarEnd);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Navbar = (_temp2 = _class = function (_React$Component) {
  _inherits(Navbar, _React$Component);

  function Navbar() {
    var _temp, _this, _ret;

    _classCallCheck(this, Navbar);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.getBurgerProps = function () {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var _ref = arguments[1];
      var isMenuActive = _ref.isMenuActive,
          toggleMenuActive = _ref.toggleMenuActive;
      return _extends({}, props, {
        isActive: isMenuActive,
        onClick: function onClick() {
          props.onClick && props.onClick();
          toggleMenuActive();
        }
      });
    }, _this.getMenuProps = function () {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var _ref2 = arguments[1];
      var isMenuActive = _ref2.isMenuActive;
      return _extends({}, props, {
        isActive: isMenuActive
      });
    }, _this.render = function () {
      var _classNames;

      var _this$props = _this.props,
          children = _this$props.children,
          className = _this$props.className,
          color = _this$props.color,
          isMenuInitiallyActive = _this$props.isMenuInitiallyActive,
          isFixedBottom = _this$props.isFixedBottom,
          isFixedTop = _this$props.isFixedTop,
          isTransparent = _this$props.isTransparent,
          props = _objectWithoutProperties(_this$props, ['children', 'className', 'color', 'isMenuInitiallyActive', 'isFixedBottom', 'isFixedTop', 'isTransparent']);

      return _react2.default.createElement(
        'nav',
        _extends({
          className: (0, _classnames2.default)('navbar', (_classNames = {}, _classNames['is-' + color] = Boolean(color), _classNames['is-fixed-bottom'] = isFixedBottom, _classNames['is-fixed-top'] = isFixedTop, _classNames['is-transparent'] = isTransparent, _classNames[className] = Boolean(className), _classNames)),
          'aria-label': 'navigation'
        }, props),
        typeof children === 'function' ? _react2.default.createElement(
          _reactToggled2.default,
          { defaultOn: isMenuInitiallyActive },
          function (_ref3) {
            var isMenuActive = _ref3.on,
                setMenuActive = _ref3.setOn,
                setMenuInactive = _ref3.setOff,
                toggleMenuActive = _ref3.toggle;
            return children({
              getBurgerProps: function getBurgerProps(props) {
                return _this.getBurgerProps(props, { isMenuActive: isMenuActive, toggleMenuActive: toggleMenuActive });
              },
              getMenuProps: function getMenuProps(props) {
                return _this.getMenuProps(props, { isMenuActive: isMenuActive });
              },
              isMenuActive: isMenuActive,
              setMenuActive: setMenuActive,
              setMenuInactive: setMenuInactive
            });
          }
        ) : children
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  return Navbar;
}(_react2.default.Component), _class.Brand = _NavbarBrand2.default, _class.Burger = _NavbarBurger2.default, _class.Divider = _NavbarDivider2.default, _class.Dropdown = _NavbarDropdown2.default, _class.End = _NavbarEnd2.default, _class.Item = _NavbarItem2.default, _class.Link = _NavbarLink2.default, _class.Menu = _NavbarMenu2.default, _class.Start = _NavbarStart2.default, _temp2);


Navbar.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes2.default.node.isRequired,
  className: _propTypes2.default.string,
  /** Color of the navbar. Available values: `white`, `light`, `dark`, `black`, `text`, `primary`, `link`, `info`, `success`, `warning`, `danger` */
  color: sharedPropTypes.color,
  /** If true, the menu is active by default. */
  isMenuInitiallyActive: _propTypes2.default.bool,
  /** If true, fixes the navbar to the bottom of the page. */
  isFixedBottom: _propTypes2.default.bool,
  /** If true, fixes the navbar to the top of the page. */
  isFixedTop: _propTypes2.default.bool,
  /** If true, makes the navbar transparent. */
  isTransparent: _propTypes2.default.bool
} : {};

Navbar.defaultProps = {
  className: null,
  color: null,
  isMenuInitiallyActive: false,
  isFixedBottom: false,
  isFixedTop: false,
  isTransparent: false
};

exports.default = Navbar;
module.exports = exports['default'];