'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var NavbarBrand = function NavbarBrand(_ref) {
  var _classNames;

  var className = _ref.className,
      isActive = _ref.isActive,
      onClick = _ref.onClick,
      target = _ref.target,
      props = _objectWithoutProperties(_ref, ['className', 'isActive', 'onClick', 'target']);

  return _react2.default.createElement(
    'a',
    _extends({
      'aria-label': 'menu',
      'aria-expanded': isActive ? 'true' : 'false',
      className: (0, _classnames2.default)('navbar-burger', (_classNames = { 'is-active': Boolean(isActive) }, _classNames[className] = Boolean(className), _classNames)),
      'data-target': target,
      onClick: onClick,
      role: 'button'
    }, props),
    _react2.default.createElement('span', { 'aria-hidden': 'true' }),
    _react2.default.createElement('span', { 'aria-hidden': 'true' }),
    _react2.default.createElement('span', { 'aria-hidden': 'true' })
  );
};

NavbarBrand.propTypes = process.env.NODE_ENV !== "production" ? {
  className: _propTypes2.default.string,
  /** If true, the burger turns into a cross. */
  isActive: _propTypes2.default.bool,
  onClick: _propTypes2.default.func,
  /** ID of the menu section. E.g. Value would be `'menu'` if <Navbar.Menu id="menu"> */
  target: _propTypes2.default.string
} : {};

NavbarBrand.defaultProps = {
  className: null,
  isActive: false,
  onClick: null,
  target: null
};

exports.default = NavbarBrand;
module.exports = exports['default'];