'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var NavbarDropdown = function NavbarDropdown(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      isBoxed = _ref.isBoxed,
      isRight = _ref.isRight,
      props = _objectWithoutProperties(_ref, ['children', 'className', 'isBoxed', 'isRight']);

  return _react2.default.createElement(
    'div',
    _extends({
      className: (0, _classnames2.default)('navbar-dropdown', (_classNames = {
        'is-boxed': isBoxed,
        'is-right': isRight
      }, _classNames[className] = Boolean(className), _classNames))
    }, props),
    children
  );
};

NavbarDropdown.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes2.default.node.isRequired,
  className: _propTypes2.default.string,
  /** If true, the dropdown is a boxed style */
  isBoxed: _propTypes2.default.bool,
  /** If true, the dropdown is right aligned */
  isRight: _propTypes2.default.bool
} : {};

NavbarDropdown.defaultProps = {
  className: null,
  isBoxed: false,
  isRight: false
};

exports.default = NavbarDropdown;
module.exports = exports['default'];