'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactToggled = require('react-toggled');

var _reactToggled2 = _interopRequireDefault(_reactToggled);

var _ClickOutside = require('../utils/ClickOutside');

var _ClickOutside2 = _interopRequireDefault(_ClickOutside);

var _NavbarDropdown = require('./NavbarDropdown');

var _NavbarDropdown2 = _interopRequireDefault(_NavbarDropdown);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var NavbarItem = function NavbarItem(_ref) {
  var children = _ref.children,
      className = _ref.className,
      dropdownTrigger = _ref.dropdownTrigger,
      Element = _ref.element,
      hasDropdown = _ref.hasDropdown,
      isActive = _ref.isActive,
      isDropdownInitiallyActive = _ref.isDropdownInitiallyActive,
      isDropup = _ref.isDropup,
      isHoverable = _ref.isHoverable,
      props = _objectWithoutProperties(_ref, ['children', 'className', 'dropdownTrigger', 'element', 'hasDropdown', 'isActive', 'isDropdownInitiallyActive', 'isDropup', 'isHoverable']);

  return _react2.default.createElement(
    _reactToggled2.default,
    { defaultOn: isDropdownInitiallyActive },
    function (_ref2) {
      var _classNames;

      var _getProps = _ref2.getTogglerProps,
          on = _ref2.on,
          show = _ref2.setOn,
          hide = _ref2.setOff,
          toggle = _ref2.toggle;
      return _react2.default.createElement(
        Element,
        _extends({
          className: (0, _classnames2.default)('navbar-item', (_classNames = {
            'has-dropdown': hasDropdown,
            'is-active': on || isActive,
            'has-dropdown-up': isDropup,
            'is-hoverable': isHoverable
          }, _classNames[className] = Boolean(className), _classNames))
        }, props),
        hasDropdown && dropdownTrigger ? _react2.default.createElement(
          _ClickOutside2.default,
          { onClickOutside: hide },
          dropdownTrigger({
            getProps: function getProps() {
              return _getProps({ style: { height: '100%' } });
            },
            show: show,
            hide: hide,
            toggle: toggle
          }),
          _react2.default.createElement(
            _NavbarDropdown2.default,
            null,
            children
          )
        ) : children
      );
    }
  );
};

NavbarItem.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes2.default.node.isRequired,
  className: _propTypes2.default.string,
  dropdownTrigger: _propTypes2.default.func,
  element: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.string]),
  /** If true, the navbar item consists of a dropdown */
  hasDropdown: _propTypes2.default.bool,
  /** If true, the navbar item is active */
  isActive: _propTypes2.default.bool,
  /** If true, the navbar item's dropdown is initially active */
  isDropdownInitiallyActive: _propTypes2.default.bool,
  /** If true, the navbar item's dropdown is actually a dropup */
  isDropup: _propTypes2.default.bool,
  /** If true, the dropdown is hoverable */
  isHoverable: _propTypes2.default.bool
} : {};

NavbarItem.defaultProps = {
  className: null,
  dropdownTrigger: null,
  element: 'div',
  hasDropdown: false,
  isActive: false,
  isDropdownInitiallyActive: false,
  isDropup: false,
  isHoverable: false
};

exports.default = NavbarItem;
module.exports = exports['default'];