'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PanelBlock = function PanelBlock(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      Element = _ref.element,
      isActive = _ref.isActive;
  return _react2.default.createElement(
    Element,
    {
      className: (0, _classnames2.default)('panel-block', (_classNames = {
        'is-active': isActive
      }, _classNames[className] = Boolean(className), _classNames))
    },
    children
  );
};

PanelBlock.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes2.default.node.isRequired,
  className: _propTypes2.default.string,
  element: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.string]),
  isActive: _propTypes2.default.bool
} : {};

PanelBlock.defaultProps = {
  className: null,
  element: 'div',
  isActive: false
};

exports.default = PanelBlock;
module.exports = exports['default'];