'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes3 = require('../_prop-types');

var sharedPropTypes = _interopRequireWildcard(_propTypes3);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Progress = function Progress(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      color = _ref.color,
      maxValue = _ref.maxValue,
      size = _ref.size,
      value = _ref.value,
      props = _objectWithoutProperties(_ref, ['children', 'className', 'color', 'maxValue', 'size', 'value']);

  return _react2.default.createElement(
    'progress',
    _extends({
      className: (0, _classnames2.default)('progress', (_classNames = {}, _classNames['is-' + color] = color, _classNames['is-' + size] = size, _classNames[className] = Boolean(className), _classNames)),
      max: maxValue,
      value: value
    }, props),
    children
  );
};

Progress.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  /** Color of notifcation. Available values: `white`, `light`, `dark`, `black`, `text`, `primary`, `link`, `info`, `success`, `warning`, `danger` */
  color: sharedPropTypes.color,
  /** Max value */
  maxValue: _propTypes2.default.string,
  /** Size of progress bar. Available values: `small`, `medium`, `large` */
  size: sharedPropTypes.size,
  /** Value of progress bar */
  value: _propTypes2.default.string.isRequired
} : {};

Progress.defaultProps = {
  children: null,
  className: null,
  color: null,
  maxValue: '100',
  size: null
};

exports.default = Progress;
module.exports = exports['default'];