'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _propTypes3 = require('../_prop-types');

var sharedPropTypes = _interopRequireWildcard(_propTypes3);

var _Field = require('../Field/Field');

var _Field2 = _interopRequireDefault(_Field);

var _FieldBody = require('../Field/FieldBody');

var _FieldBody2 = _interopRequireDefault(_FieldBody);

var _FieldControl = require('../Field/FieldControl');

var _FieldControl2 = _interopRequireDefault(_FieldControl);

var _FieldLabel = require('../Field/FieldLabel');

var _FieldLabel2 = _interopRequireDefault(_FieldLabel);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RadioField = function (_React$Component) {
  _inherits(RadioField, _React$Component);

  function RadioField() {
    var _temp, _this, _ret;

    _classCallCheck(this, RadioField);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.state = { value: _this.props.value }, _this.componentDidUpdate = function (prevProps) {
      var value = _this.props.value;
      var prevValue = prevProps.value;

      if (value !== prevValue) {
        _this.setState({ value: value });
      }
    }, _this.handleChange = function (value) {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          propValue = _this$props.value;

      if (propValue) return;
      _this.setState({ value: value });
      onChange && onChange(value);
    }, _this.render = function () {
      var _this$props2 = _this.props,
          children = _this$props2.children,
          className = _this$props2.className,
          color = _this$props2.color,
          helpText = _this$props2.helpText,
          inputProps = _this$props2.inputProps,
          isHorizontal = _this$props2.isHorizontal,
          labelComponent = _this$props2.labelComponent,
          labelName = _this$props2.labelName,
          labelSize = _this$props2.labelSize,
          name = _this$props2.name,
          onChange = _this$props2.onChange,
          options = _this$props2.options,
          props = _objectWithoutProperties(_this$props2, ['children', 'className', 'color', 'helpText', 'inputProps', 'isHorizontal', 'labelComponent', 'labelName', 'labelSize', 'name', 'onChange', 'options']);

      var value = _this.state.value;

      return _react2.default.createElement(
        _Field2.default,
        _extends({ isHorizontal: isHorizontal }, props),
        (labelName || labelComponent) && _react2.default.createElement(
          _FieldLabel2.default,
          { isHorizontal: isHorizontal, size: labelSize },
          labelName || labelComponent
        ),
        _react2.default.createElement(
          _FieldBody2.default,
          null,
          _react2.default.createElement(
            _Field2.default,
            { color: color, helpText: helpText },
            _react2.default.createElement(
              _FieldControl2.default,
              null,
              options.map(function (option, i) {
                return (
                  /* eslint-disable react/no-array-index-key */
                  _react2.default.createElement(
                    'label',
                    { key: i, className: 'radio', disabled: option.isDisabled },
                    _react2.default.createElement('input', _extends({
                      'aria-label': labelName,
                      checked: option.value === value,
                      className: className,
                      disabled: option.isDisabled,
                      onChange: function onChange(e) {
                        return _this.handleChange(option.value);
                      },
                      name: name,
                      type: 'radio',
                      value: option.value
                    }, inputProps)),
                    ' ',
                    option.label
                  )
                );
              })
            )
          )
        )
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  return RadioField;
}(_react2.default.Component);

RadioField.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  /** Color of input field. */
  color: sharedPropTypes.color,
  /** Displays help text */
  helpText: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),
  /** The label that appears above the input */
  labelComponent: _propTypes2.default.element,
  /** The label that appears above the input */
  labelName: _propTypes2.default.string,
  /** Size of the label field */
  labelSize: sharedPropTypes.size,
  inputProps: _propTypes2.default.object,
  /** Input field is horizontal */
  isHorizontal: _propTypes2.default.bool,
  /** Name of the input field */
  name: _propTypes2.default.string,
  /** Function to invoke on change */
  onChange: _propTypes2.default.func,
  /** List of selectable options */
  options: _propTypes2.default.array,
  /** Value of the input */
  value: _propTypes2.default.string
} : {};

RadioField.defaultProps = {
  children: null,
  className: null,
  color: null,
  helpText: null,
  labelComponent: null,
  labelName: null,
  labelSize: null,
  inputProps: {},
  isHorizontal: false,
  name: null,
  onChange: null,
  options: [],
  value: undefined
};

exports.default = RadioField;
module.exports = exports['default'];