'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes3 = require('../_prop-types');

var sharedPropTypes = _interopRequireWildcard(_propTypes3);

var _Field = require('../Field/Field');

var _Field2 = _interopRequireDefault(_Field);

var _FieldBody = require('../Field/FieldBody');

var _FieldBody2 = _interopRequireDefault(_FieldBody);

var _FieldControl = require('../Field/FieldControl');

var _FieldControl2 = _interopRequireDefault(_FieldControl);

var _FieldLabel = require('../Field/FieldLabel');

var _FieldLabel2 = _interopRequireDefault(_FieldLabel);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var SelectField = function SelectField(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      color = _ref.color,
      helpText = _ref.helpText,
      inputSize = _ref.inputSize,
      id = _ref.id,
      inputProps = _ref.inputProps,
      isDisabled = _ref.isDisabled,
      isHorizontal = _ref.isHorizontal,
      isLoading = _ref.isLoading,
      isMultiSelect = _ref.isMultiSelect,
      isRounded = _ref.isRounded,
      labelComponent = _ref.labelComponent,
      labelName = _ref.labelName,
      labelSize = _ref.labelSize,
      leftIconName = _ref.leftIconName,
      onBlur = _ref.onBlur,
      _onChange = _ref.onChange,
      onFocus = _ref.onFocus,
      options = _ref.options,
      state = _ref.state,
      value = _ref.value,
      props = _objectWithoutProperties(_ref, ['children', 'className', 'color', 'helpText', 'inputSize', 'id', 'inputProps', 'isDisabled', 'isHorizontal', 'isLoading', 'isMultiSelect', 'isRounded', 'labelComponent', 'labelName', 'labelSize', 'leftIconName', 'onBlur', 'onChange', 'onFocus', 'options', 'state', 'value']);

  return _react2.default.createElement(
    _Field2.default,
    _extends({ id: id, isHorizontal: isHorizontal, label: labelName, labelSize: labelSize }, props),
    (labelName || labelComponent) && _react2.default.createElement(
      _FieldLabel2.default,
      { isHorizontal: isHorizontal, isNormal: true, size: labelSize },
      labelName || labelComponent
    ),
    _react2.default.createElement(
      _FieldBody2.default,
      null,
      _react2.default.createElement(
        _Field2.default,
        { color: color, helpText: helpText },
        _react2.default.createElement(
          _FieldControl2.default,
          { leftIconName: leftIconName },
          _react2.default.createElement(
            'div',
            {
              className: (0, _classnames2.default)('select', (_classNames = {}, _classNames['is-' + color] = color, _classNames['is-' + inputSize] = inputSize, _classNames['is-loading'] = isLoading, _classNames['is-multiple'] = isMultiSelect, _classNames['is-rounded'] = isRounded, _classNames[className] = Boolean(className), _classNames)),
              disabled: isDisabled
            },
            _react2.default.createElement(
              'select',
              _extends({
                'aria-label': labelName,
                className: (0, _classnames2.default)(state ? 'is-' + state : ''),
                multiple: isMultiSelect,
                onBlur: onBlur,
                onChange: function onChange(e) {
                  return _onChange && _onChange(e.target.value, e);
                },
                onFocus: onBlur,
                value: value
              }, inputProps),
              options.map(function (option, i) {
                return (
                  /* eslint-disable react/no-array-index-key */
                  _react2.default.createElement(
                    'option',
                    { key: i, value: option.value },
                    option.label
                  )
                );
              })
            )
          )
        )
      )
    )
  );
};

SelectField.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  /** Color of input field. */
  color: sharedPropTypes.color,
  /** Displays help text */
  helpText: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),
  /** The label that appears above the input */
  labelComponent: _propTypes2.default.element,
  /** The label that appears above the input */
  labelName: _propTypes2.default.string,
  /** Size of the label field */
  labelSize: sharedPropTypes.size,
  /** Name of left field icon */
  leftIconName: _propTypes2.default.string,
  /** ID for the input field */
  id: _propTypes2.default.string,
  inputProps: _propTypes2.default.object,
  /** Size of the input field */
  inputSize: sharedPropTypes.size,
  /** Disable the input field */
  isDisabled: _propTypes2.default.bool,
  /** Input field is horizontal */
  isHorizontal: _propTypes2.default.bool,
  /** Input field is loading */
  isLoading: _propTypes2.default.bool,
  /** Enable multi-select */
  isMultiSelect: _propTypes2.default.bool,
  /** Input field is rounded */
  isRounded: _propTypes2.default.bool,
  /** Function to invoke on blur */
  onBlur: _propTypes2.default.func,
  /** Function to invoke on change */
  onChange: _propTypes2.default.func,
  /** Set of options to select from */
  options: _propTypes2.default.array,
  /** Function to invoke on focus */
  onFocus: _propTypes2.default.func,
  /** State of field */
  state: sharedPropTypes.state,
  /** Value of the input */
  value: _propTypes2.default.string
} : {};

SelectField.defaultProps = {
  children: null,
  className: null,
  color: null,
  helpText: null,
  labelComponent: null,
  labelName: null,
  labelSize: null,
  leftIconName: null,
  id: null,
  inputProps: {},
  inputSize: null,
  isDisabled: false,
  isHorizontal: false,
  isLoading: false,
  isMultiSelect: false,
  isRounded: false,
  onBlur: null,
  onChange: null,
  options: [],
  onFocus: null,
  state: null,
  value: undefined
};

exports.default = SelectField;
module.exports = exports['default'];