'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _TableHead = require('./TableHead');

var _TableHead2 = _interopRequireDefault(_TableHead);

var _TableBody = require('./TableBody');

var _TableBody2 = _interopRequireDefault(_TableBody);

var _TableFoot = require('./TableFoot');

var _TableFoot2 = _interopRequireDefault(_TableFoot);

var _TableRow = require('./TableRow');

var _TableRow2 = _interopRequireDefault(_TableRow);

var _TableCell = require('./TableCell');

var _TableCell2 = _interopRequireDefault(_TableCell);

var _TableCellHead = require('./TableCellHead');

var _TableCellHead2 = _interopRequireDefault(_TableCellHead);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Table = (_temp2 = _class = function (_React$Component) {
  _inherits(Table, _React$Component);

  function Table() {
    var _temp, _this, _ret;

    _classCallCheck(this, Table);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.render = function () {
      var _classNames;

      var _this$props = _this.props,
          children = _this$props.children,
          className = _this$props.className,
          isBordered = _this$props.isBordered,
          isFullWidth = _this$props.isFullWidth,
          isHoverable = _this$props.isHoverable,
          isNarrow = _this$props.isNarrow,
          isStriped = _this$props.isStriped,
          props = _objectWithoutProperties(_this$props, ['children', 'className', 'isBordered', 'isFullWidth', 'isHoverable', 'isNarrow', 'isStriped']);

      return _react2.default.createElement(
        'table',
        _extends({
          className: (0, _classnames2.default)('table', (_classNames = {
            'is-bordered': isBordered,
            'is-fullwidth': isFullWidth,
            'is-hoverable': isHoverable,
            'is-narrow': isNarrow,
            'is-striped': isStriped
          }, _classNames[className] = Boolean(className), _classNames))
        }, props),
        children
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  return Table;
}(_react2.default.Component), _class.Head = _TableHead2.default, _class.Body = _TableBody2.default, _class.Foot = _TableFoot2.default, _class.Row = _TableRow2.default, _class.Cell = _TableCell2.default, _class.CellHead = _TableCellHead2.default, _temp2);


Table.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes2.default.node.isRequired,
  className: _propTypes2.default.string,
  /** Is the table bordered? */
  isBordered: _propTypes2.default.bool,
  /** Is the table full width? */
  isFullWidth: _propTypes2.default.bool,
  /** Is the table hoverable? */
  isHoverable: _propTypes2.default.bool,
  /** Is the table narrow? */
  isNarrow: _propTypes2.default.bool,
  /** Is the table striped? */
  isStriped: _propTypes2.default.bool
} : {};

Table.defaultProps = {
  className: null,
  isBordered: false,
  isFullWidth: false,
  isHoverable: false,
  isNarrow: false,
  isStriped: false
};

exports.default = Table;
module.exports = exports['default'];