'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes3 = require('../_prop-types');

var sharedPropTypes = _interopRequireWildcard(_propTypes3);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Tabs = function Tabs(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      align = _ref.align,
      size = _ref.size,
      isBoxed = _ref.isBoxed,
      isToggle = _ref.isToggle,
      isToggleRounded = _ref.isToggleRounded,
      isFullWidth = _ref.isFullWidth,
      props = _objectWithoutProperties(_ref, ['children', 'className', 'align', 'size', 'isBoxed', 'isToggle', 'isToggleRounded', 'isFullWidth']);

  return _react2.default.createElement(
    'div',
    _extends({
      className: (0, _classnames2.default)('tabs', (_classNames = {}, _classNames['is-' + align] = align, _classNames['is-' + size] = size, _classNames['is-boxed'] = isBoxed, _classNames['is-toggle'] = isToggle, _classNames['is-toggle-rounded'] = isToggleRounded, _classNames['is-fullwidth'] = isFullWidth, _classNames[className] = Boolean(className), _classNames))
    }, props),
    _react2.default.createElement(
      'ul',
      null,
      children
    )
  );
};

Tabs.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes2.default.node.isRequired,
  className: _propTypes2.default.string,
  /** Alignment of the dropdown. Available values: `left`, `centered`, `right` */
  align: sharedPropTypes.align,
  /** Size of the tabs Available values: `small`, `medium`, `large` */
  size: sharedPropTypes.size,
  /** Are tabs box styled? */
  isBoxed: _propTypes2.default.boolean,
  /** Are tabs toggle styled? */
  isToggle: _propTypes2.default.boolean,
  /** Are tabs rounded toggle styled? */
  isToggleRounded: _propTypes2.default.boolean,
  /** Are tabs fullwidth? */
  isFullWidth: _propTypes2.default.boolean
} : {};

Tabs.defaultProps = {
  className: null,
  align: null,
  size: null,
  isBoxed: false,
  isToggle: false,
  isToggleRounded: false,
  isFullWidth: false
};

exports.default = Tabs;
module.exports = exports['default'];