'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteralLoose(['\n  ', ';\n'], ['\n  ', ';\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _styledSystem = require('styled-system');

var _propTypes3 = require('../_prop-types');

var sharedPropTypes = _interopRequireWildcard(_propTypes3);

var _Delete = require('../Delete/Delete');

var _Delete2 = _interopRequireDefault(_Delete);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _taggedTemplateLiteralLoose(strings, raw) { strings.raw = raw; return strings; }

var DeleteWrapper = _styledComponents2.default.span(_templateObject, _styledSystem.space);

var getDeleteWrapperMarginLeft = function getDeleteWrapperMarginLeft(_ref) {
  var children = _ref.children,
      size = _ref.size;

  if (children) {
    return size === 'medium' || size === 'large' ? 2 : 1;
  }
  return 0;
};

var Tag = function Tag(_ref2) {
  var _classNames;

  var children = _ref2.children,
      className = _ref2.className,
      color = _ref2.color,
      isRounded = _ref2.isRounded,
      onClickDelete = _ref2.onClickDelete,
      size = _ref2.size,
      props = _objectWithoutProperties(_ref2, ['children', 'className', 'color', 'isRounded', 'onClickDelete', 'size']);

  return _react2.default.createElement(
    'span',
    _extends({
      className: (0, _classnames2.default)('tag', (_classNames = {}, _classNames['is-' + color] = Boolean(color), _classNames['is-' + size] = Boolean(size), _classNames['is-rounded'] = isRounded, _classNames[className] = Boolean(className), _classNames))
    }, props),
    children,
    onClickDelete && _react2.default.createElement(
      DeleteWrapper,
      { ml: getDeleteWrapperMarginLeft({ children: children, size: size }) },
      _react2.default.createElement(_Delete2.default, { onClick: onClickDelete, size: size })
    )
  );
};

Tag.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  /** Tag color. Available values: `white`, `light`, `dark`, `black`, `text`, `primary`, `link`, `info`, `success`, `warning`, `danger` */
  color: sharedPropTypes.color,
  /** Is tag round? */
  isRounded: _propTypes2.default.bool,
  /** Function to invoke when the delete button is pressed. Delete button is visible when `onClickDelete` is populated. */
  onClickDelete: _propTypes2.default.func,
  /** Size of tag. Available values: `medium`, `large` */
  size: sharedPropTypes.size
} : {};

Tag.defaultProps = {
  children: null,
  className: null,
  color: null,
  isRounded: false,
  onClickDelete: null,
  size: 'small'
};

exports.default = Tag;
module.exports = exports['default'];