'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactAutosizeTextarea = require('react-autosize-textarea');

var _reactAutosizeTextarea2 = _interopRequireDefault(_reactAutosizeTextarea);

var _propTypes3 = require('../_prop-types');

var sharedPropTypes = _interopRequireWildcard(_propTypes3);

var _Field = require('../Field/Field');

var _Field2 = _interopRequireDefault(_Field);

var _FieldBody = require('../Field/FieldBody');

var _FieldBody2 = _interopRequireDefault(_FieldBody);

var _FieldControl = require('../Field/FieldControl');

var _FieldControl2 = _interopRequireDefault(_FieldControl);

var _FieldLabel = require('../Field/FieldLabel');

var _FieldLabel2 = _interopRequireDefault(_FieldLabel);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var TextAreaField = function TextAreaField(_ref) {
  var _classNames;

  var autoComplete = _ref.autoComplete,
      autoFocus = _ref.autoFocus,
      children = _ref.children,
      className = _ref.className,
      color = _ref.color,
      helpText = _ref.helpText,
      inputSize = _ref.inputSize,
      id = _ref.id,
      inputProps = _ref.inputProps,
      isDisabled = _ref.isDisabled,
      isLoading = _ref.isLoading,
      isHorizontal = _ref.isHorizontal,
      isReadOnly = _ref.isReadOnly,
      labelName = _ref.labelName,
      labelComponent = _ref.labelComponent,
      labelSize = _ref.labelSize,
      onBlur = _ref.onBlur,
      _onChange = _ref.onChange,
      onFocus = _ref.onFocus,
      placeholder = _ref.placeholder,
      rows = _ref.rows,
      state = _ref.state,
      value = _ref.value,
      props = _objectWithoutProperties(_ref, ['autoComplete', 'autoFocus', 'children', 'className', 'color', 'helpText', 'inputSize', 'id', 'inputProps', 'isDisabled', 'isLoading', 'isHorizontal', 'isReadOnly', 'labelName', 'labelComponent', 'labelSize', 'onBlur', 'onChange', 'onFocus', 'placeholder', 'rows', 'state', 'value']);

  return _react2.default.createElement(
    _Field2.default,
    _extends({ id: id, isHorizontal: isHorizontal }, props),
    (labelName || labelComponent) && _react2.default.createElement(
      _FieldLabel2.default,
      { isHorizontal: isHorizontal, isNormal: true, size: labelSize },
      labelName || labelComponent
    ),
    _react2.default.createElement(
      _FieldBody2.default,
      null,
      _react2.default.createElement(
        _Field2.default,
        { color: color, helpText: helpText },
        _react2.default.createElement(
          _FieldControl2.default,
          { color: color, isLoading: isLoading },
          _react2.default.createElement(_reactAutosizeTextarea2.default, _extends({
            'aria-label': labelName,
            autoComplete: autoComplete,
            autoFocus: autoFocus,
            className: (0, _classnames2.default)('textarea', (_classNames = {}, _classNames['is-' + color] = color, _classNames['is-' + inputSize] = inputSize, _classNames['is-' + state] = state, _classNames[className] = Boolean(className), _classNames)),
            disabled: isDisabled,
            onBlur: onBlur,
            onChange: function onChange(e) {
              return _onChange && _onChange(e.target.value, e);
            },
            onFocus: onBlur,
            placeholder: placeholder,
            readOnly: isReadOnly,
            rows: rows,
            value: value
          }, inputProps))
        )
      )
    )
  );
};

TextAreaField.propTypes = process.env.NODE_ENV !== "production" ? {
  /** Set an autocomplete attribute on the field */
  autoComplete: _propTypes2.default.string,
  /** Automatically set focus to the field */
  autoFocus: _propTypes2.default.bool,
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  /** Color of input field. */
  color: sharedPropTypes.color,
  /** Displays help text */
  helpText: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),
  inputProps: _propTypes2.default.object,
  /** The label that appears above the input */
  labelComponent: _propTypes2.default.element,
  /** The label that appears above the input */
  labelName: _propTypes2.default.string,
  /** Size of the label field */
  labelSize: sharedPropTypes.size,
  /** ID for the input field */
  id: _propTypes2.default.string,
  /** Size of the input field */
  inputSize: sharedPropTypes.size,
  /** Disable the input field */
  isDisabled: _propTypes2.default.bool,
  /** Input field is loading */
  isLoading: _propTypes2.default.bool,
  /** Input field is horizontal */
  isHorizontal: _propTypes2.default.bool,
  /** Input field is read only */
  isReadOnly: _propTypes2.default.bool,
  /** Function to invoke on blur */
  onBlur: _propTypes2.default.func,
  /** Function to invoke on change */
  onChange: _propTypes2.default.func,
  /** Function to invoke on focus */
  onFocus: _propTypes2.default.func,
  /** Placeholder of the input */
  placeholder: _propTypes2.default.string,
  /** Minimum number of rows */
  rows: _propTypes2.default.number,
  /** State of field */
  state: sharedPropTypes.state,
  /** Value of the input */
  value: _propTypes2.default.string
} : {};

TextAreaField.defaultProps = {
  autoComplete: null,
  autoFocus: false,
  children: null,
  className: null,
  color: null,
  helpText: null,
  labelComponent: null,
  labelName: null,
  labelSize: null,
  id: null,
  inputProps: {},
  inputSize: null,
  isDisabled: false,
  isLoading: false,
  isHorizontal: false,
  isReadOnly: false,
  onBlur: null,
  onChange: null,
  onFocus: null,
  placeholder: null,
  rows: 3,
  state: null,
  value: undefined
};

exports.default = TextAreaField;
module.exports = exports['default'];