'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes3 = require('../_prop-types');

var sharedPropTypes = _interopRequireWildcard(_propTypes3);

var _Field = require('../Field/Field');

var _Field2 = _interopRequireDefault(_Field);

var _FieldBody = require('../Field/FieldBody');

var _FieldBody2 = _interopRequireDefault(_FieldBody);

var _FieldControl = require('../Field/FieldControl');

var _FieldControl2 = _interopRequireDefault(_FieldControl);

var _FieldLabel = require('../Field/FieldLabel');

var _FieldLabel2 = _interopRequireDefault(_FieldLabel);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var TextField = function TextField(_ref) {
  var _classNames;

  var autoComplete = _ref.autoComplete,
      autoFocus = _ref.autoFocus,
      children = _ref.children,
      className = _ref.className,
      color = _ref.color,
      helpText = _ref.helpText,
      inputProps = _ref.inputProps,
      inputSize = _ref.inputSize,
      isDisabled = _ref.isDisabled,
      isExpanded = _ref.isExpanded,
      isLoading = _ref.isLoading,
      isHorizontal = _ref.isHorizontal,
      isReadOnly = _ref.isReadOnly,
      isRounded = _ref.isRounded,
      labelComponent = _ref.labelComponent,
      labelName = _ref.labelName,
      labelSize = _ref.labelSize,
      leftAddonComponent = _ref.leftAddonComponent,
      leftIconName = _ref.leftIconName,
      max = _ref.max,
      maxLength = _ref.maxLength,
      min = _ref.min,
      minLength = _ref.minLength,
      name = _ref.name,
      onBlur = _ref.onBlur,
      _onChange = _ref.onChange,
      onFocus = _ref.onFocus,
      pattern = _ref.pattern,
      placeholder = _ref.placeholder,
      rightAddonComponent = _ref.rightAddonComponent,
      rightIconName = _ref.rightIconName,
      spellCheck = _ref.spellCheck,
      state = _ref.state,
      step = _ref.step,
      value = _ref.value,
      props = _objectWithoutProperties(_ref, ['autoComplete', 'autoFocus', 'children', 'className', 'color', 'helpText', 'inputProps', 'inputSize', 'isDisabled', 'isExpanded', 'isLoading', 'isHorizontal', 'isReadOnly', 'isRounded', 'labelComponent', 'labelName', 'labelSize', 'leftAddonComponent', 'leftIconName', 'max', 'maxLength', 'min', 'minLength', 'name', 'onBlur', 'onChange', 'onFocus', 'pattern', 'placeholder', 'rightAddonComponent', 'rightIconName', 'spellCheck', 'state', 'step', 'value']);

  return _react2.default.createElement(
    _Field2.default,
    _extends({ isHorizontal: isHorizontal }, props),
    (labelName || labelComponent) && _react2.default.createElement(
      _FieldLabel2.default,
      { isHorizontal: isHorizontal, isNormal: true, size: labelSize },
      labelName || labelComponent
    ),
    _react2.default.createElement(
      _FieldBody2.default,
      null,
      _react2.default.createElement(
        _Field2.default,
        { color: color, hasAddons: Boolean(leftAddonComponent || rightAddonComponent), helpText: helpText },
        leftAddonComponent && _react2.default.createElement(
          _FieldControl2.default,
          null,
          leftAddonComponent
        ),
        _react2.default.createElement(
          _FieldControl2.default,
          {
            color: color,
            isExpanded: isExpanded,
            isLoading: isLoading,
            leftIconName: leftIconName,
            rightIconName: rightIconName
          },
          _react2.default.createElement('input', _extends({
            'aria-label': labelName,
            autoComplete: autoComplete,
            autoFocus: autoFocus,
            className: (0, _classnames2.default)('input', (_classNames = {}, _classNames['is-' + color] = Boolean(color), _classNames['is-' + inputSize] = Boolean(inputSize), _classNames['is-' + state] = Boolean(state), _classNames['is-rounded'] = isRounded, _classNames[className] = Boolean(className), _classNames)),
            disabled: isDisabled,
            max: max,
            maxLength: maxLength,
            min: min,
            minLength: minLength,
            name: name,
            onBlur: onBlur,
            onChange: function onChange(e) {
              return _onChange && _onChange(e.target.value, e);
            },
            onFocus: onBlur,
            pattern: pattern,
            placeholder: placeholder,
            readOnly: isReadOnly,
            spellCheck: spellCheck,
            step: step,
            value: value
          }, inputProps))
        ),
        rightAddonComponent && _react2.default.createElement(
          _FieldControl2.default,
          null,
          rightAddonComponent
        )
      )
    )
  );
};

TextField.propTypes = process.env.NODE_ENV !== "production" ? {
  /** Set an autocomplete attribute on the field */
  autoComplete: _propTypes2.default.string,
  /** Automatically set focus to the field */
  autoFocus: _propTypes2.default.bool,
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  /** Color of input field. */
  color: sharedPropTypes.color,
  /** Displays help text */
  helpText: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),
  inputProps: _propTypes2.default.object,
  /** The label that appears above the input */
  labelComponent: _propTypes2.default.element,
  /** The label that appears above the input */
  labelName: _propTypes2.default.string,
  /** Size of the label field */
  labelSize: sharedPropTypes.size,
  /** Addon component to display on the left of the field */
  leftAddonComponent: _propTypes2.default.element,
  /** Name of left field icon */
  leftIconName: _propTypes2.default.string,
  /** Size of the input field */
  inputSize: sharedPropTypes.size,
  /** Disable the input field */
  isDisabled: _propTypes2.default.bool,
  /** Is input field expanded when addon component exists */
  isExpanded: _propTypes2.default.bool,
  /** Input field is loading */
  isLoading: _propTypes2.default.bool,
  /** Input field is horizontal */
  isHorizontal: _propTypes2.default.bool,
  /** Input field is read only */
  isReadOnly: _propTypes2.default.bool,
  /** Input field is rounded */
  isRounded: _propTypes2.default.bool,
  /** Max value for numeric field */
  max: _propTypes2.default.number,
  /** Max length for a alphanumeric field */
  maxLength: _propTypes2.default.number,
  /** Min value for numeric field */
  min: _propTypes2.default.number,
  /** Min length for a alphanumeric field */
  minLength: _propTypes2.default.number,
  /** Name of the input field */
  name: _propTypes2.default.string,
  /** Function to invoke on blur */
  onBlur: _propTypes2.default.func,
  /** Function to invoke on change */
  onChange: _propTypes2.default.func,
  /** Function to invoke on focus */
  onFocus: _propTypes2.default.func,
  /** Regex to check value against */
  pattern: _propTypes2.default.string,
  /** Placeholder of the input */
  placeholder: _propTypes2.default.string,
  /** Addon component to display on the right of the field */
  rightAddonComponent: _propTypes2.default.element,
  /** Name of right field icon */
  rightIconName: _propTypes2.default.string,
  /** Enable spell check for input field */
  spellCheck: _propTypes2.default.bool,
  /** State of field */
  state: sharedPropTypes.state,
  /** Increment/decrement step value for numeric field */
  step: _propTypes2.default.number,
  /** Type of input */
  type: _propTypes2.default.string,
  /** Value of the input */
  value: _propTypes2.default.string
} : {};

TextField.defaultProps = {
  autoComplete: null,
  autoFocus: false,
  children: null,
  className: null,
  color: null,
  helpText: null,
  labelComponent: null,
  labelName: null,
  labelSize: null,
  leftAddonComponent: null,
  leftIconName: null,
  inputProps: {},
  inputSize: null,
  isDisabled: false,
  isExpanded: false,
  isLoading: false,
  isHorizontal: false,
  isReadOnly: false,
  isRounded: false,
  max: null,
  maxLength: null,
  min: null,
  minLength: null,
  name: null,
  onBlur: null,
  onChange: null,
  onFocus: null,
  pattern: null,
  placeholder: null,
  rightAddonComponent: null,
  rightIconName: null,
  spellCheck: false,
  state: null,
  step: null,
  type: 'text',
  value: undefined
};

exports.default = TextField;
module.exports = exports['default'];