'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Title = function Title(_ref) {
  var _classNames;

  var children = _ref.children,
      className = _ref.className,
      element = _ref.element,
      isSpaced = _ref.isSpaced,
      isSubTitle = _ref.isSubTitle,
      size = _ref.size,
      props = _objectWithoutProperties(_ref, ['children', 'className', 'element', 'isSpaced', 'isSubTitle', 'size']);

  var Element = element || 'h' + (size || '1');
  return _react2.default.createElement(
    Element,
    _extends({
      className: (0, _classnames2.default)((_classNames = {}, _classNames['is-' + size] = Boolean(size), _classNames['is-spaced'] = isSpaced, _classNames.title = !isSubTitle, _classNames.subtitle = isSubTitle, _classNames[className] = Boolean(className), _classNames))
    }, props),
    children
  );
};

Title.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes2.default.node.isRequired,
  className: _propTypes2.default.string,
  /** Custom element to use for title. Example: `'p'` */
  element: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),
  /** Does the title have padding? */
  isSpaced: _propTypes2.default.bool,
  /** Is the title a subtitle? */
  isSubTitle: _propTypes2.default.bool,
  /** Size of title. Available values: `"1"`, `"2"`, `"3"`, `"4"`, `"5"`, `"6"` */
  size: _propTypes2.default.oneOf(['1', '2', '3', '4', '5', '6'])
} : {};

Title.defaultProps = {
  className: null,
  element: null,
  isSpaced: false,
  isSubTitle: false,
  size: null
};

exports.default = Title;
module.exports = exports['default'];